/**** BOM CX^X폜XgAhvV[W ****/

SET QUOTED_IDENTIFIER ON;
SET ANSI_NULLS ON;
GO

USE [bom6_archive];

IF object_id(N'sp_admin_archive_instance_delete') IS NOT NULL
BEGIN
	DROP PROCEDURE [dbo].[sp_admin_archive_instance_delete];
END
GO


CREATE PROCEDURE [dbo].[sp_admin_archive_instance_delete]
	@nInstanceId INT
AS
BEGIN
	SET NOCOUNT ON;
	DECLARE @SUCCESS_STATUS INT;
	DECLARE @ERROR_STATUS INT;
	DECLARE @ROW_COUNT INT;
	DECLARE @SUM_COUNT INT;

	SET @SUCCESS_STATUS = 0;
	SET @ERROR_STATUS = 0;
	SET @ROW_COUNT = 0;
	SET @SUM_COUNT = 0;	

	BEGIN TRANSACTION;
	

    --bom_archive_watche[u
    DELETE FROM bom_archive_watch
    WHERE instance_setup_id = @nInstanceId;
	SET @ROW_COUNT = @@ROWCOUNT;
	SET @SUM_COUNT = @SUM_COUNT + @ROW_COUNT;
	SET @ERROR_STATUS = @@ERROR;							
    IF @ERROR_STATUS = @SUCCESS_STATUS
		PRINT N'@@bom_archive_watch    e[ũf[^ ' + CAST(@ROW_COUNT AS NVARCHAR) + N'폜܂B';
	ELSE
		PRINT N'@@bom_archive_watch    e[ũf[^폜Ɏs܂B(Error=' + CAST(@@ERROR AS NVARCHAR) + N')';


	--bom_archive_sysinfoe[u
	DELETE FROM bom_archive_sysinfo
	WHERE instance_setup_id = @nInstanceId;
	SET @ROW_COUNT = @@ROWCOUNT;
	SET @SUM_COUNT = @SUM_COUNT + @ROW_COUNT;
	SET @ERROR_STATUS = @@ERROR;							
    IF @ERROR_STATUS = @SUCCESS_STATUS
		PRINT N'@@bom_archive_sysinfo  e[ũf[^ ' + CAST(@ROW_COUNT AS NVARCHAR) + N'폜܂B';
	ELSE
		PRINT N'@@bom_archive_sysinfo  e[ũf[^폜Ɏs܂B(Error=' + CAST(@@ERROR AS NVARCHAR) + N')';


	--bom_archive_ntevente[u
	DELETE FROM bom_archive_ntevent
	WHERE instance_setup_id = @nInstanceId;
	SET @ROW_COUNT = @@ROWCOUNT;
	SET @SUM_COUNT = @SUM_COUNT + @ROW_COUNT;
	SET @ERROR_STATUS = @@ERROR;							
    IF @ERROR_STATUS = @SUCCESS_STATUS
		PRINT N'@@bom_archive_ntevent  e[ũf[^ ' + CAST(@ROW_COUNT AS NVARCHAR) + N'폜܂B';
	ELSE
		PRINT N'@@bom_archive_ntevent  e[ũf[^폜Ɏs܂B(Error=' + CAST(@@ERROR AS NVARCHAR) + N')';

	
	--bom_archive_historye[u
	DELETE FROM bom_archive_history
	WHERE instance_setup_id = @nInstanceId;
	SET @ROW_COUNT = @@ROWCOUNT;
	SET @SUM_COUNT = @SUM_COUNT + @ROW_COUNT;
	SET @ERROR_STATUS = @@ERROR;							
    IF @ERROR_STATUS = @SUCCESS_STATUS
		PRINT N'@@bom_archive_history  e[ũf[^ ' + CAST(@ROW_COUNT AS NVARCHAR) + N'폜܂B';
	ELSE
		PRINT N'@@bom_archive_history  e[ũf[^폜Ɏs܂B(Error=' + CAST(@@ERROR AS NVARCHAR) + N')';
		

	--bom_archive_performancee[u
	DELETE FROM bom_archive_performance
	WHERE instance_setup_id = @nInstanceId;
	SET @ROW_COUNT = @@ROWCOUNT;
	SET @SUM_COUNT = @SUM_COUNT + @ROW_COUNT;
	SET @ERROR_STATUS = @@ERROR;							
    IF @ERROR_STATUS = @SUCCESS_STATUS
		PRINT N'@@bom_archive_performance  e[ũf[^ ' + CAST(@ROW_COUNT AS NVARCHAR) + N'폜܂B';
	ELSE
		PRINT N'@@bom_archive_performance  e[ũf[^폜Ɏs܂B(Error=' + CAST(@@ERROR AS NVARCHAR) + N')';
		

	--bom_archive_performance_counteride[u
	DELETE FROM bom_archive_performance_counterid
	WHERE instance_setup_id = @nInstanceId;
	SET @ROW_COUNT = @@ROWCOUNT;
	SET @SUM_COUNT = @SUM_COUNT + @ROW_COUNT;
	SET @ERROR_STATUS = @@ERROR;							
    IF @ERROR_STATUS = @SUCCESS_STATUS
		PRINT N'@@bom_archive_performance_counterid  e[ũf[^ ' + CAST(@ROW_COUNT AS NVARCHAR) + N'폜܂B';
	ELSE
		PRINT N'@@bom_archive_performance_counterid  e[ũf[^폜Ɏs܂B(Error=' + CAST(@@ERROR AS NVARCHAR) + N')';


	--bom_watch_condition
	DELETE FROM bom_watch_condition
	WHERE watch_setup_id IN ( SELECT watch_setup_id
							  FROM bom_watch
							  WHERE appl_setup_id IN ( SELECT appl_setup_id
													   FROM bom_appl
													   WHERE instance_setup_id = @nInstanceId
													 )
							);
	SET @ROW_COUNT = @@ROWCOUNT;
	SET @SUM_COUNT = @SUM_COUNT + @ROW_COUNT;
	SET @ERROR_STATUS = @@ERROR;							
    IF @ERROR_STATUS = @SUCCESS_STATUS
		PRINT N'@@bom_watch_condition  e[ũf[^ ' + CAST(@ROW_COUNT AS NVARCHAR) + N'폜܂B';							
	ELSE
		PRINT N'@@bom_watch_condition  e[ũf[^폜Ɏs܂B(Error=' + CAST(@@ERROR AS NVARCHAR) + N')';

	
	--bom_watche[u
	DELETE FROM bom_watch
	WHERE appl_setup_id  IN ( SELECT appl_setup_id
							  FROM bom_appl
							  WHERE instance_setup_id = @nInstanceId
							);
	SET @ROW_COUNT = @@ROWCOUNT;
	SET @SUM_COUNT = @SUM_COUNT + @ROW_COUNT;
	SET @ERROR_STATUS = @@ERROR;							
    IF @ERROR_STATUS = @SUCCESS_STATUS
		PRINT N'@@bom_watch            e[ũf[^ ' + CAST(@ROW_COUNT AS NVARCHAR) + N'폜܂B';
	ELSE
		PRINT N'@@bom_watch            e[ũf[^폜Ɏs܂B(Error=' + CAST(@@ERROR AS NVARCHAR) + N')';


	--bom_apple[u
	DELETE FROM bom_appl
	WHERE instance_setup_id = @nInstanceId;
	SET @ROW_COUNT = @@ROWCOUNT;
	SET @SUM_COUNT = @SUM_COUNT + @ROW_COUNT;
	SET @ERROR_STATUS = @@ERROR;							
    IF @ERROR_STATUS = @SUCCESS_STATUS
		PRINT N'@@bom_appl             e[ũf[^ ' + CAST(@ROW_COUNT AS NVARCHAR) + N'폜܂B';
	ELSE
		PRINT N'@@bom_appl             e[ũf[^폜Ɏs܂B(Error=' + CAST(@@ERROR AS NVARCHAR) + N')';
	

	--bom_instancee[u
    DELETE FROM bom_instance
    WHERE instance_setup_id = @nInstanceId;
	SET @ROW_COUNT = @@ROWCOUNT;
	SET @SUM_COUNT = @SUM_COUNT + @ROW_COUNT;
	SET @ERROR_STATUS = @@ERROR;							
    IF @ERROR_STATUS = @SUCCESS_STATUS
		PRINT N'@@bom_instance         e[ũf[^ ' + CAST(@ROW_COUNT AS NVARCHAR) + N'폜܂B';
	ELSE
		PRINT N'@@bom_instance         e[ũf[^폜Ɏs܂B(Error=' + CAST(@@ERROR AS NVARCHAR) + N')';
		

	COMMIT TRANSACTION;
--	ROLLBACK TRANSACTION;

	PRINT N' ';
	PRINT N'y폜z' + CAST(@SUM_COUNT AS NVARCHAR) + N'';
	
	SET NOCOUNT OFF;
END
GO

