/**** BOM CX^Xꗗ\ XNvg ****/
SET NOCOUNT ON;


USE [bom6_archive];
GO

BEGIN
	DECLARE @ROW_COUNT INT;
	SET @ROW_COUNT = 0;
	
	SELECT 
		bom_instance_subquery.instance_setup_id AS InstanceID,
		CASE 
			WHEN (LEN(bom_machine_subquery.machine_unique_name) + len(bom_instance_subquery.instance_name) + LEN(bom_product_info_subquery.product_name) + LEN(bom_product_info_subquery.service_release_name)+ 3) > 65
				THEN LEFT(bom_machine_subquery.machine_unique_name+'\'+bom_instance_subquery.instance_name+' '+bom_product_info_subquery.product_name+' '+bom_product_info_subquery.service_release_name, 43) + '~ ' +
					RIGHT(bom_machine_subquery.machine_unique_name+'\'+bom_instance_subquery.instance_name+' '+bom_product_info_subquery.product_name+' '+bom_product_info_subquery.service_release_name, 20)
			ELSE LEFT(bom_machine_subquery.machine_unique_name+'\'+bom_instance_subquery.instance_name+' '+bom_product_info_subquery.product_name+' '+bom_product_info_subquery.service_release_name, 65)
		END AS InstanceName
	FROM (
		SELECT 	instance_setup_id,
				machine_id,
				product_code,
				service_release_code,
				RTRIM(instance_name) AS instance_name
		FROM 	bom_instance
	) AS bom_instance_subquery
	left join (
			SELECT	machine_id,
					RTRIM(machine_unique_name) AS machine_unique_name
			FROM	bom_machine
		) AS bom_machine_subquery
	ON bom_instance_subquery.machine_id = bom_machine_subquery.machine_id
	left join (
			SELECT	product_code,
					service_release_code,
					RTRIM(product_name) AS product_name,
					RTRIM(service_release_name) AS service_release_name
			FROM	bom_product_info
		) AS bom_product_info_subquery
	ON bom_instance_subquery.product_code = bom_product_info_subquery.product_code AND bom_instance_subquery.service_release_code = bom_product_info_subquery.service_release_code
	ORDER BY bom_instance_subquery.instance_setup_id;

	SET @ROW_COUNT = @@ROWCOUNT;
	PRINT N' ';
	PRINT N'yz' + CAST(@ROW_COUNT AS NVARCHAR) + N'';
END
GO

SET NOCOUNT OFF;

