USE [bom6_archive]
GO

SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

-----------------------------------------------------------------------------
-- BOM Rollup Packagȅǉ
PRINT N'BOM6 Rollup Packageւ̃AbvO[hs܂B'
IF ((SELECT COUNT(*) FROM [dbo].[bom_product_info] WHERE [service_release_code] = '602') <= 0)
BEGIN
	INSERT INTO [bom_product_info] VALUES ('20100','602','BOM 6','','ʏ퐻i')
	INSERT INTO [bom_product_info] VALUES ('20101','602','BOM 6','',']')
	INSERT INTO [bom_product_info] VALUES ('21100','602','BOM 6','','LinuxIvV')
	INSERT INTO [bom_product_info] VALUES ('21101','602','BOM 6','','LinuxIvV]')
	INSERT INTO [bom_product_info] VALUES ('22100','602','BOM 6','','VMwareIvV')
	INSERT INTO [bom_product_info] VALUES ('22101','602','BOM 6','','VMwareIvV]')
END
ELSE
BEGIN
	PRINT N'łɃAbvO[hς݂łB'
END
GO

-----------------------------------------------------------------------------
-- SR1ւ̃AbvO[h
PRINT N'BOM6 ArchiveDB SR1ւ̃AbvO[hs܂B'
IF object_id(N'is_bom6_sr1_db') IS NULL
BEGIN

	-- BOM6 SR1 ̕
	INSERT INTO [bom_product_info] VALUES ('20100','610','BOM 6','SR1.0','ʏ퐻i')
	INSERT INTO [bom_product_info] VALUES ('20101','610','BOM 6','SR1.0',']')
	INSERT INTO [bom_product_info] VALUES ('21100','610','BOM 6','SR1.0','LinuxIvV')
	INSERT INTO [bom_product_info] VALUES ('21101','610','BOM 6','SR1.0','LinuxIvV]')
	INSERT INTO [bom_product_info] VALUES ('22100','610','BOM 6','SR1.0','VMwareIvV')
	INSERT INTO [bom_product_info] VALUES ('22101','610','BOM 6','SR1.0','VMwareIvV]')
END
ELSE
BEGIN
	PRINT N'łɃAbvO[hς݂łB'

	-- t@NV̍폜
	DROP FUNCTION [dbo].[is_bom6_sr1_db];
END
GO

-- t@NV`쐬
CREATE FUNCTION [dbo].[is_bom6_sr1_db] () RETURNS int AS BEGIN RETURN 1 END
GO

GRANT EXECUTE ON [dbo].[is_bom6_sr1_db] TO [Bom6ArchiveMgr];
GRANT EXECUTE ON [dbo].[is_bom6_sr1_db] TO [Bom6ArchiveSvc];
GO


-----------------------------------------------------------------------------
-- SR2ւ̃AbvO[h
PRINT N'BOM6 ArchiveDB SR2ւ̃AbvO[hs܂B'
IF object_id(N'is_bom6_sr2_db') IS NULL
BEGIN

	-- BOM6 SR2 ̕
	INSERT INTO [bom_product_info] VALUES ('20100','620','BOM 6','SR2.0','ʏ퐻i')
	INSERT INTO [bom_product_info] VALUES ('20101','620','BOM 6','SR2.0',']')
	INSERT INTO [bom_product_info] VALUES ('21100','620','BOM 6','SR2.0','LinuxIvV')
	INSERT INTO [bom_product_info] VALUES ('21101','620','BOM 6','SR2.0','LinuxIvV]')
	INSERT INTO [bom_product_info] VALUES ('22100','620','BOM 6','SR2.0','VMwareIvV')
	INSERT INTO [bom_product_info] VALUES ('22101','620','BOM 6','SR2.0','VMwareIvV]')
END
ELSE
BEGIN
	PRINT N'łɃAbvO[hς݂łB'
	
	-- t@NV̍폜
	DROP FUNCTION [dbo].[is_bom6_sr2_db];
END
GO

-- t@NV`쐬
CREATE FUNCTION [dbo].[is_bom6_sr2_db] () RETURNS int AS BEGIN RETURN 1 END
GO

GRANT EXECUTE ON [dbo].[is_bom6_sr2_db] TO [Bom6ArchiveMgr];
GRANT EXECUTE ON [dbo].[is_bom6_sr2_db] TO [Bom6ArchiveSvc];
GO

-----------------------------------------------------------------------------
-- SR2gւ̃AbvO[h
PRINT N'BOM6 ArchiveDB SR2gւ̃AbvO[hs܂B'
IF NOT EXISTS
(
   SELECT
    iname
   FROM
    (
      SELECT
        t.name AS tname
        ,i.name AS iname
      FROM
        sys.indexes AS i 
      INNER JOIN sys.tables t ON
        i.object_id = t.object_id 
      INNER JOIN sys.schemas AS s ON
        t.schema_id = s.schema_id 
      WHERE t.name = 'bom_archive_sysinfo' AND i.name = 'IX_bom_archive_sysinfo_archive_time'
    )sysinfo_indexies
)
BEGIN
 CREATE NONCLUSTERED INDEX [IX_bom_archive_sysinfo_archive_time]
 ON [dbo].[bom_archive_sysinfo] ([archive_time])
 INCLUDE ([instance_setup_id])
 PRINT N'AbvO[h܂B'
END
ELSE
BEGIN
 PRINT N'łɃAbvO[hς݂łB'
END

-----------------------------------------------------------------------------
-- BOM7ւ̃AbvO[h
PRINT N'BOM7 ArchiveDBւ̃AbvO[hs܂B'
IF object_id(N'is_bom7_db') IS NULL
BEGIN

	-- BOM7 ̕
	INSERT INTO [bom_product_info] VALUES ('25100','700','BOM 7',N'','ʏ퐻i')
	INSERT INTO [bom_product_info] VALUES ('25101','700','BOM 7',N'',']')
	INSERT INTO [bom_product_info] VALUES ('26100','700','BOM 7',N'','LinuxIvV')
	INSERT INTO [bom_product_info] VALUES ('26101','700','BOM 7',N'','LinuxIvV]')
	INSERT INTO [bom_product_info] VALUES ('27100','700','BOM 7',N'','VMwareIvV')
	INSERT INTO [bom_product_info] VALUES ('27101','700','BOM 7',N'','VMwareIvV]')
END
ELSE
BEGIN
	PRINT N'łɃAbvO[hς݂łB'
	
	-- t@NV̍폜
	DROP FUNCTION [dbo].[is_bom7_db];
END
GO

-- t@NV`쐬
CREATE FUNCTION [dbo].[is_bom7_db] () RETURNS int AS BEGIN RETURN 1 END
GO

GRANT EXECUTE ON [dbo].[is_bom7_db] TO [Bom6ArchiveMgr];
GRANT EXECUTE ON [dbo].[is_bom7_db] TO [Bom6ArchiveSvc];
GO

-----------------------------------------------------------------------------
-- BOM7SR1ւ̃AbvO[h
PRINT N'BOM7SR1 ArchiveDBւ̃AbvO[hs܂B'
IF object_id(N'is_bom7sr1_db') IS NULL
BEGIN
	-- SR1ւ̃AbvO[hoOis_bom7sr1_dbȂ̂Ŏf[^Ń`FbNĂȂ΃f[^𗬂ނ悤ɂB
	Declare @sr1count int
	select @sr1count = (select count(service_release_code) from bom_product_info where service_release_code = '710')
	IF @sr1count <= 0
	BEGIN
		-- BOM7SR1 ̕
		INSERT INTO [bom_product_info] VALUES ('25100','710','BOM 7',N'SR1.0','ʏ퐻i')
		INSERT INTO [bom_product_info] VALUES ('25101','710','BOM 7',N'SR1.0',']')
		INSERT INTO [bom_product_info] VALUES ('26100','710','BOM 7',N'SR1.0','LinuxIvV')
		INSERT INTO [bom_product_info] VALUES ('26101','710','BOM 7',N'SR1.0','LinuxIvV]')
		INSERT INTO [bom_product_info] VALUES ('27100','710','BOM 7',N'SR1.0','VMwareIvV')
		INSERT INTO [bom_product_info] VALUES ('27101','710','BOM 7',N'SR1.0','VMwareIvV]')
	END
END
ELSE
BEGIN
	PRINT N'łɃAbvO[hς݂łB'
	
	-- t@NV̍폜
	DROP FUNCTION [dbo].[is_bom7sr1_db];
END
GO

-- t@NV`쐬
CREATE FUNCTION [dbo].[is_bom7sr1_db] () RETURNS int AS BEGIN RETURN 1 END
GO

GRANT EXECUTE ON [dbo].[is_bom7sr1_db] TO [Bom6ArchiveMgr];
GRANT EXECUTE ON [dbo].[is_bom7sr1_db] TO [Bom6ArchiveSvc];
GO

-----------------------------------------------------------------------------
-- BOM7SR2ւ̃AbvO[h
PRINT N'BOM7SR2 ArchiveDBւ̃AbvO[hs܂B'
IF object_id(N'is_bom7sr2_db') IS NULL
BEGIN

	-- BOM7SR2 ̕
	INSERT INTO [bom_product_info] VALUES ('25100','720','BOM 7',N'SR2.0','ʏ퐻i')
	INSERT INTO [bom_product_info] VALUES ('25101','720','BOM 7',N'SR2.0',']')
	INSERT INTO [bom_product_info] VALUES ('26100','720','BOM 7',N'SR2.0','LinuxIvV')
	INSERT INTO [bom_product_info] VALUES ('26101','720','BOM 7',N'SR2.0','LinuxIvV]')
	INSERT INTO [bom_product_info] VALUES ('27100','720','BOM 7',N'SR2.0','VMwareIvV')
	INSERT INTO [bom_product_info] VALUES ('27101','720','BOM 7',N'SR2.0','VMwareIvV]')
END
ELSE
BEGIN
	PRINT N'łɃAbvO[hς݂łB'
	
	-- t@NV̍폜
	DROP FUNCTION [dbo].[is_bom7sr2_db];
END
GO

-- t@NV`쐬
CREATE FUNCTION [dbo].[is_bom7sr2_db] () RETURNS int AS BEGIN RETURN 1 END
GO

GRANT EXECUTE ON [dbo].[is_bom7sr2_db] TO [Bom6ArchiveMgr];
GRANT EXECUTE ON [dbo].[is_bom7sr2_db] TO [Bom6ArchiveSvc];
GO

-----------------------------------------------------------------------------
-- BOM7SR3ւ̃AbvO[h
PRINT N'BOM7SR3 ArchiveDBւ̃AbvO[hs܂B'
IF object_id(N'is_bom7sr3_db') IS NULL
BEGIN

	-- BOM7SR3 ̕
	INSERT INTO [bom_product_info] VALUES ('25100','730','BOM 7',N'SR3.0','ʏ퐻i')
	INSERT INTO [bom_product_info] VALUES ('25101','730','BOM 7',N'SR3.0',']')
	INSERT INTO [bom_product_info] VALUES ('26100','730','BOM 7',N'SR3.0','LinuxIvV')
	INSERT INTO [bom_product_info] VALUES ('26101','730','BOM 7',N'SR3.0','LinuxIvV]')
	INSERT INTO [bom_product_info] VALUES ('27100','730','BOM 7',N'SR3.0','VMwareIvV')
	INSERT INTO [bom_product_info] VALUES ('27101','730','BOM 7',N'SR3.0','VMwareIvV]')
END
ELSE
BEGIN
	PRINT N'łɃAbvO[hς݂łB'
	
	-- t@NV̍폜
	DROP FUNCTION [dbo].[is_bom7sr3_db];
END
GO

-- t@NV`쐬
CREATE FUNCTION [dbo].[is_bom7sr3_db] () RETURNS int AS BEGIN RETURN 1 END
GO

GRANT EXECUTE ON [dbo].[is_bom7sr3_db] TO [Bom6ArchiveMgr];
GRANT EXECUTE ON [dbo].[is_bom7sr3_db] TO [Bom6ArchiveSvc];
GO

-----------------------------------------------------------------------------
-- BOM7SR4ւ̃AbvO[h
PRINT N'BOM7SR4 ArchiveDBւ̃AbvO[hs܂B'
IF object_id(N'is_bom7sr4_db') IS NULL
BEGIN

	-- BOM7SR4 ̕
	INSERT INTO [bom_product_info] VALUES ('25100','740','BOM 7',N'SR4.0','ʏ퐻i')
	INSERT INTO [bom_product_info] VALUES ('25101','740','BOM 7',N'SR4.0',']')
	INSERT INTO [bom_product_info] VALUES ('26100','740','BOM 7',N'SR4.0','LinuxIvV')
	INSERT INTO [bom_product_info] VALUES ('26101','740','BOM 7',N'SR4.0','LinuxIvV]')
	INSERT INTO [bom_product_info] VALUES ('27100','740','BOM 7',N'SR4.0','VMwareIvV')
	INSERT INTO [bom_product_info] VALUES ('27101','740','BOM 7',N'SR4.0','VMwareIvV]')
END
ELSE
BEGIN
	PRINT N'łɃAbvO[hς݂łB'
	
	-- t@NV̍폜
	DROP FUNCTION [dbo].[is_bom7sr4_db];
END
GO

-- t@NV`쐬
CREATE FUNCTION [dbo].[is_bom7sr4_db] () RETURNS int AS BEGIN RETURN 1 END
GO

GRANT EXECUTE ON [dbo].[is_bom7sr4_db] TO [Bom6ArchiveMgr];
GRANT EXECUTE ON [dbo].[is_bom7sr4_db] TO [Bom6ArchiveSvc];
GO

-----------------------------------------------------------------------------
-- BOM8ւ̃AbvO[h
PRINT N'BOM8 ArchiveDBւ̃AbvO[hs܂B'
IF object_id(N'is_bom8_db') IS NULL
BEGIN
	BEGIN TRY
		BEGIN TRANSACTION

		DECLARE @product_name NCHAR(32) = N'BOM 8'
		DECLARE @service_release_code NCHAR(32) = N'800'
		DECLARE @service_release_name NCHAR(32) = N''

		-- BOM8 ̕
		INSERT INTO [dbo].[bom_product_info] 
			(product_code, service_release_code, product_name, service_release_name, product_type)
		VALUES
			('11100', @service_release_code, @product_name, N'', 'ʏ퐻i'),
			('11101', @service_release_code, @product_name, N'', ']'),
			('13100', @service_release_code, @product_name, N'', 'LinuxIvV'),
			('13101', @service_release_code, @product_name, N'', 'LinuxIvV]'),
			('16100', @service_release_code, @product_name, N'', 'VMwareIvV'),
			('16101', @service_release_code, @product_name, N'', 'VMwareIvV]');

		-- t@NV`쐬
		exec ('CREATE FUNCTION [dbo].[is_bom8_db] () RETURNS int AS BEGIN RETURN 1 END')

		GRANT EXECUTE ON [dbo].[is_bom8_db] TO [Bom6ArchiveMgr];
		GRANT EXECUTE ON [dbo].[is_bom8_db] TO [Bom6ArchiveSvc];

		COMMIT TRANSACTION;
	END TRY
	BEGIN CATCH
		ROLLBACK TRANSACTION
		PRINT N'AbvO[hɎs܂B';
	END CATCH
END
ELSE
BEGIN
	PRINT N'łɃAbvO[hς݂łB'
END
GO

-----------------------------------------------------------------------------
-- BOM8 SR1 ւ̃AbvO[h
PRINT N'BOM8SR1 ArchiveDBւ̃AbvO[hs܂B'
IF object_id(N'is_bom8sr1_db') IS NULL
BEGIN
	BEGIN TRY
		BEGIN TRANSACTION

		DECLARE @product_name NCHAR(32) = N'BOM 8'
		DECLARE @service_release_code NCHAR(32) = N'810'
		DECLARE @service_release_name NCHAR(32) = N'SR1.0'

		-- BOM8 ̕
		INSERT INTO [dbo].[bom_product_info] 
			(product_code, service_release_code, product_name, service_release_name, product_type)
		VALUES
			('11100', @service_release_code, @product_name, @service_release_name, 'ʏ퐻i'),
			('11101', @service_release_code, @product_name, @service_release_name, ']'),
			('13100', @service_release_code, @product_name, @service_release_name, 'LinuxIvV'),
			('13101', @service_release_code, @product_name, @service_release_name, 'LinuxIvV]'),
			('16100', @service_release_code, @product_name, @service_release_name, 'VMwareIvV'),
			('16101', @service_release_code, @product_name, @service_release_name, 'VMwareIvV]');

		-- t@NV`쐬
		exec ('CREATE FUNCTION [dbo].[is_bom8sr1_db] () RETURNS int AS BEGIN RETURN 1 END')

		GRANT EXECUTE ON [dbo].[is_bom8sr1_db] TO [Bom6ArchiveMgr];
		GRANT EXECUTE ON [dbo].[is_bom8sr1_db] TO [Bom6ArchiveSvc];

		COMMIT TRANSACTION;
	END TRY
	BEGIN CATCH
		ROLLBACK TRANSACTION
		PRINT N'AbvO[hɎs܂B';
	END CATCH
END
ELSE
BEGIN
	PRINT N'łɃAbvO[hς݂łB'
END
GO

-----------------------------------------------------------------------------
-- BOM8 SR2 ւ̃AbvO[h
PRINT N'BOM8SR2 ArchiveDBւ̃AbvO[hs܂B'
IF object_id(N'is_bom8sr2_db') IS NULL
BEGIN
	BEGIN TRY
		BEGIN TRANSACTION

		DECLARE @product_name NCHAR(32) = N'BOM 8'
		DECLARE @service_release_code NCHAR(32) = N'820'
		DECLARE @service_release_name NCHAR(32) = N'SR2.0'

		-- BOM8 ̕
		INSERT INTO [dbo].[bom_product_info] 
			(product_code, service_release_code, product_name, service_release_name, product_type)
		VALUES
			('11100', @service_release_code, @product_name, @service_release_name, 'ʏ퐻i'),
			('11101', @service_release_code, @product_name, @service_release_name, ']'),
			('13100', @service_release_code, @product_name, @service_release_name, 'LinuxIvV'),
			('13101', @service_release_code, @product_name, @service_release_name, 'LinuxIvV]'),
			('16100', @service_release_code, @product_name, @service_release_name, 'VMwareIvV'),
			('16101', @service_release_code, @product_name, @service_release_name, 'VMwareIvV]');

		-- t@NV`쐬
		exec ('CREATE FUNCTION [dbo].[is_bom8sr2_db] () RETURNS int AS BEGIN RETURN 1 END')

		GRANT EXECUTE ON [dbo].[is_bom8sr2_db] TO [Bom6ArchiveMgr];
		GRANT EXECUTE ON [dbo].[is_bom8sr2_db] TO [Bom6ArchiveSvc];

		COMMIT TRANSACTION;
	END TRY
	BEGIN CATCH
		ROLLBACK TRANSACTION
		PRINT N'AbvO[hɎs܂B';
	END CATCH
END
ELSE
BEGIN
	PRINT N'łɃAbvO[hς݂łB'
END
GO
