/**** XgAhvV[W 쐬 ****/

USE [bom_report]
GO

SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

Create Function [dbo].[fnParseAddInfo](@testStr nvarchar(max), @targetKey nvarchar(64))
Returns @infoTbl Table(
	keyStr varchar(256),
	valueStr varchar(max)
)
as
Begin

  declare @samplestr nvarchar(max)
  set @samplestr = @testStr
  declare @infoseparetor as varchar(1)
  declare @keyValseparetor as varchar(1)
  set @infoSeparetor = '"'
  set @keyValSeparetor = ''''

  declare @infoCheckComplete as int
  set @infoCheckComplete = 0
  declare @infoCount as int
  set @infoCount = 0

  while( @infoCheckComplete <> 1)
  begin
    declare @info_s as int
    declare @info_e as int

    if(@infoCount=0)
    begin
      set @info_s = CHARINDEX(@infoSeparetor, @samplestr)
    end
    else
    begin
      set @info_s = CHARINDEX(@infoSeparetor, @samplestr,@info_e+1)
    end
    set @info_e = CHARINDEX(@infoSeparetor, @samplestr,@info_s+1)

    if @info_s<> 0 and @info_e > @info_s
    begin
      declare @info_key_s as int
      declare @info_key_e as int
      declare @info_val_s as int
      declare @info_val_e as int
      if(@infoCount=0)
      begin
        set @info_key_s = CHARINDEX(@keyValSeparetor, @samplestr)
	  end
	  else
	  begin
        set @info_key_s = CHARINDEX(@keyValSeparetor, @samplestr, @info_val_e+1 )
	  end
      set @info_key_e = CHARINDEX(@keyValSeparetor, @samplestr, @info_key_s+1 )
      set @info_val_s = CHARINDEX(@keyValSeparetor, @samplestr, @info_key_e+1 )
      set @info_val_e = CHARINDEX(@keyValSeparetor, @samplestr, @info_val_s+1 )

      declare @info_key varchar(256)
	  set @info_key = SUBSTRING(@samplestr,@info_key_s+1,@info_key_e-@info_key_s-1)
      declare @info_val varchar(max)
	  set @info_val = SUBSTRING(@samplestr,@info_val_s+1,@info_val_e-@info_val_s-1)

	  if @info_key = @targetKey
	  begin 
        insert into @infoTbl values(@info_key,@info_val)
	    break
	  end
      set @infoCount = @infoCount+1

    end
    else
    begin
      set @infoCheckComplete = 1
    end
  end

  Return
End


GO

USE [bom_report]
GO

SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

create procedure [dbo].[sp_ForceDisconnect]
as
delete from bom_report.dbo.t_environmental where [environment_item] = 'IS_RUNNING'
GO

USE [bom_report]
GO

SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO



Create Function [dbo].[fnParseWmiKeyValue](@testStr nvarchar(max), @targetKey nvarchar(64))
Returns @infoTbl Table(
	keyStr varchar(256),
	valueStr varchar(max)
)
as
Begin

  declare @sampleKey nvarchar(max)
  set @sampleKey = @targetKey+'%%'

  declare @isTarget as int
  select @isTarget = count(*) where @testStr like @sampleKey
  if(@isTarget=0) Return

  declare @keyValSeparetor as varchar(1)
  set @keyValSeparetor = '='

  declare @keyStartTrigger as varchar(1)
  set @keyStartTrigger = '.'

  declare @infoseparetor as varchar(1)
  set @infoSeparetor = ','

  declare @valSeparetor as varchar(1)
  set @valSeparetor = '"'

  declare @infoCount as int
  set @infoCount = 0

  declare @infoCheckComplete as int
  set @infoCheckComplete = 0

  declare @samplestr nvarchar(max)
  set @samplestr = @testStr

  declare @info_s as int
  declare @info_e as int
  declare @info_val_s as int
  declare @info_val_e as int

  while( @infoCheckComplete <> 1)
  begin

    if(@infoCount=0)
    begin
      set @info_s = CHARINDEX(@keyStartTrigger, @samplestr)
    end
    else
    begin
      set @info_s = CHARINDEX(@infoSeparetor, @samplestr,@info_val_e+1)
    end

    set @info_e = CHARINDEX(@keyValSeparetor, @samplestr,@info_s+1)

    if @info_s<> 0 and @info_e > @info_s
    begin
      declare @info_key varchar(256)
      set @info_key = SUBSTRING(@samplestr,@info_s+1,@info_e-@info_s-1)

      set @info_val_s = CHARINDEX(@valSeparetor, @samplestr, @info_e+1 )
      set @info_val_e = CHARINDEX(@valSeparetor, @samplestr, @info_val_s+1 )

      declare @info_val varchar(max)
      set @info_val = SUBSTRING(@samplestr,@info_val_s+1,@info_val_e-@info_val_s-1)

      insert into @infoTbl values(@info_key,@info_val)

      set @infoCount = @infoCount+1

    end
    else
    begin
      set @infoCheckComplete = 1
    end
  end

  Return
End


GO

