USE [bom_report]
GO

SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

-----------------------------------------------------------------------------
-- SR1ւ̃AbvO[h
PRINT N'BOM7 ReportDB SR1ւ̃AbvO[hs܂B'
IF OBJECT_ID (N'[dbo].[is_bom7report_sr1_db]', N'FN') IS NOT NULL  
BEGIN
    PRINT N'łɃAbvO[hς݂łB'

    -- t@NV̍폜
    DROP FUNCTION [dbo].[is_bom7report_sr1_db];
END

IF OBJECT_ID (N'[dbo].[fnParseVMProperty]', N'TF') IS NOT NULL  
BEGIN
    -- t@NV̍폜
    DROP FUNCTION [dbo].[fnParseVMProperty];
END

GO

Create Function [dbo].[fnParseVMProperty](@testStr nvarchar(max), @infoseparetor nvarchar(1), @targetKey nvarchar(512),@noIndex as bit)
Returns @infoTbl Table(
    keyStr varchar(512),
    infoIndex nvarchar(16),
    infoType nvarchar(max)
)
as
Begin

  declare @samplestr nvarchar(max)
  set @samplestr = @testStr

  declare @infoCheckComplete as int
  set @infoCheckComplete = 0
  declare @strLen as int
  set @strLen = DATALENGTH(@samplestr)

  declare @findTarget as int
  set @findTarget = 0
  declare @findIndex as int
  set @findIndex = 0

  declare @info_key varchar(512)
  set @info_key = ''
  declare @info_index varchar(16)
  set @info_index = ''
  declare @info_type varchar(max)
  set @info_type = ''

  declare @substrKey varchar(64)
  set @substrKey = ''

  declare @info_s as int
  set @info_s = 0
  declare @info_e as int
  set @info_e = 0

  while( @infoCheckComplete <> 1)
  begin

    set @substrKey = ''
    set @info_s = @info_e+1
    set @info_e = CHARINDEX(@infoSeparetor, @samplestr,@info_s+1)

    /* serch Key */
    if (@findTarget=0)
    begin
      if(@info_e > @info_s)
      begin
        set @substrKey = ''
        set @substrKey = SUBSTRING(@samplestr,@info_s,@info_e-@info_s)

        if @info_key+@substrKey = @targetKey
        begin
          /* find */
          set @info_key = @info_key+@substrKey
          set @findTarget = 1
          if (@noIndex=1)
          begin
            set @findIndex = 1
            set @info_index = 0
          end
        end
        else
        begin
          set @info_key = @info_key+@substrKey+@infoSeparetor
        end
      end
      /* not found */
      else
      begin
        set @infoCheckComplete = 1
      end
    end
    /* get Index */
    else if(@findIndex=0)
    begin
      if(@info_e > @info_s)
      begin
        set @substrKey = SUBSTRING(@samplestr,@info_s,@info_e-@info_s)
        set @info_index = @substrKey

        set @findIndex =1
      end
      /* not found */
      else
      begin
        set @infoCheckComplete = 1
      end
    end
    /* get Others */
    else
      begin
        set @substrKey = SUBSTRING(@samplestr,@info_s,@strLen-@info_s)
        set @info_type = @substrKey

        insert into @infoTbl values(@info_key,@info_index,@info_type)
        set @infoCheckComplete = 1
    end
  end
  return
End

GO

-- t@NV`쐬
CREATE FUNCTION [dbo].[is_bom7report_sr1_db] () RETURNS int AS BEGIN RETURN 1 END
GO

GRANT EXECUTE ON [dbo].[is_bom7report_sr1_db] TO [bomreportmgruser];
GO

-----------------------------------------------------------------------------


