//*****************************************************************************
// Copyright (C) 2013-2017 SAY Technologies, Inc. All rights reserved.
//*****************************************************************************

var objInstanceSummary = {};

$(document).ready(function(){
    //他のタブの情報を削除する
	if(window.parent.tabPageClear != undefined) window.parent.tabPageClear();

	//=========================================================================
	// プロパティ
	//=========================================================================
	objInstanceSummary.instanceId = $('#instanceId').val();
	objInstanceSummary.iconHashTable = {'GROUP':'folderClosed32',
			'BOM5WINDOWS':'bom5Windows32',
			'BOM5LINUX':'bom5Linux32',
			'BOM5VMWARE':'bom5Vmware32',
			'BOM6WINDOWS':'bom6Windows32',
			'BOM6LINUX':'bom6Linux32',
			'BOM6VMWARE':'bom6Vmware32',
			'BOM7WINDOWS':'bom7Windows32',
			'BOM7LINUX':'bom7Linux32',
			'BOM7VMWARE':'bom7Vmware32',
			'BOM8WINDOWS':'bom8Windows32',
			'BOM8LINUX':'bom8Linux32',
			'BOM8VMWARE':'bom8Vmware32'};
	objInstanceSummary.statusIconHashTable = {'disconnectComputer':'instanseStateDisconnectComputer128',
			'disconnectHelper':'instanseStateDisconnectHelper128',
			'disconnectAgent':'instanceStateDisconnectAgent128',
			'failure':'instanseStateFailure128',
			'danger':'instanseStateDanger128',
			'warning':'instanseStateWarning128',
			'normal':'instanseStateSuccess128',
			'invisible':''};
	objInstanceSummary.instanceNameHashTable = {'BOM5WINDOWS':'BOM 5.0 基本製品 インスタンス',
			'BOM5LINUX':'BOM 5.0 Linuxオプション インスタンス',
			'BOM5VMWARE':'BOM 5.0 VMwareオプション インスタンス',
			'BOM6WINDOWS':'BOM 6.0 基本製品 インスタンス',
			'BOM6LINUX':'BOM 6.0 Linuxオプション インスタンス',
			'BOM6VMWARE':'BOM 6.0 VMwareオプション インスタンス',
			'BOM7WINDOWS':'BOM 7.0 基本製品 インスタンス',
			'BOM7LINUX':'BOM 7.0 Linuxオプション インスタンス',
			'BOM7VMWARE':'BOM 7.0 VMwareオプション インスタンス',
			'BOM8WINDOWS':'BOM 8.0 基本製品 インスタンス',
			'BOM8LINUX':'BOM 8.0 Linuxオプション インスタンス',
			'BOM8VMWARE':'BOM 8.0 VMwareオプション インスタンス'};
	objInstanceSummary.objectMapList = [];

	//=========================================================================
	// メソッド
	//=========================================================================
	//-------------------------------------------------------------------------
	// 要素の取得要求
	//-------------------------------------------------------------------------
	objInstanceSummary.ajaxInstanceSummaryRequest = function(){
		//Loadingタイマー開始
		$('body').viewLoadingScreen();
		//var ajaxParam = {'AjaxParam0' : this.instanceId};
		//ajaxParam.onFailure = onAjaxFailure;
		//Kumu.Ajax.executeTeedaAjax(detailsInstance_instanceSummaryAction_ajaxInstanceSummary, ajaxParam, Kumu.Ajax.RESPONSE_TYPE_JSON);
		$.get('/Indicator/view/teeda.ajax', {'component' : 'detailsInstance_instanceSummaryAction', 'action' : 'ajaxInstanceSummary', 'AjaxParam0' : objInstanceSummary.instanceId}, detailsInstance_instanceSummaryAction_ajaxInstanceSummary, 'json');
	};

	//-------------------------------------------------------------------------
	// 要素の取得応答
	//-------------------------------------------------------------------------
	objInstanceSummary.ajaxInstanceSummaryResponse = function(objectMapList){
		//サーバーからのデータチェック
		if(!('id' in objectMapList)){
			objInstanceSummary.objectMapList = null;
			return;
		}
		objInstanceSummary.objectMapList = objectMapList;

		//ステータスの設定
		if(!('normal' in objInstanceSummary.objectMapList)){
			objInstanceSummary.objectMapList['normal'] = 0;
		}
		if(!('warning' in objInstanceSummary.objectMapList)){
			objInstanceSummary.objectMapList['warning'] = 0;
		}
		if(!('danger' in objInstanceSummary.objectMapList)){
			objInstanceSummary.objectMapList['danger'] = 0;
		}
		if(!('failure' in objInstanceSummary.objectMapList)){
			objInstanceSummary.objectMapList['failure'] = 0;
		}
		if(!('disconnectAgent' in objInstanceSummary.objectMapList)){
			objInstanceSummary.objectMapList['disconnectAgent'] = false;
		}
		if(!('disconnectHelper' in objInstanceSummary.objectMapList)){
			objInstanceSummary.objectMapList['disconnectHelper'] = false;
		}
		if(!('disconnectComputer' in objInstanceSummary.objectMapList)){
			objInstanceSummary.objectMapList['disconnectComputer'] = false;
		}

		if(!('pollingEnable' in objInstanceSummary.objectMapList)){
			objInstanceSummary.objectMapList['pollingEnable'] = false;
		}
		if(!('pollingInterval' in objInstanceSummary.objectMapList)){
			objInstanceSummary.objectMapList['pollingInterval'] = '--';
		}
		if(!('nextPollingDate' in objInstanceSummary.objectMapList)){
			objInstanceSummary.objectMapList['nextPollingDate'] = '--';
		}
		if(!('lastPollingDate' in objInstanceSummary.objectMapList)){
			objInstanceSummary.objectMapList['lastPollingDate'] = '--';
		}
		if(!('duringPollingExecute' in objInstanceSummary.objectMapList)){
			objInstanceSummary.objectMapList['duringPollingExecute'] = false;
		}
	};

	//ページ表示の更新処理
	objInstanceSummary.pageUpdate = function(){
		try{
			if(objInstanceSummary.objectMapList != null){
				var doPollingFlag = true;
				//ステータス
				var tableBody = $('#summaryStatusTable');
				var toolTipTable = {
						'disconnectComputer': 'コンピューター接続エラー',
						'disconnectHelper': 'ヘルパーサービス接続エラー',
						'disconnectAgent': '監視サービス停止中',
						'failure': '失敗',
						'danger':'危険',
						'warning':'注意',
						'normal':'正常',
						'noStatus':''};
				var iconImgSrcTable = {
						'disconnectComputer': '../../images/summaryDisconnectComputer128.png',
						'disconnectHelper': '../../images/summaryDisconnectHelper128.png',
						'disconnectAgent': '../../images/summaryDisconnectAgent128.png',
						'failure': '../../images/summaryFailure128.png',
						'danger': '../../images/summaryDanger128.png',
						'warning': '../../images/summaryWarning128.png',
						'normal': '../../images/summaryInformation128.png'
				};
				var loadingIcon = $('<img src="../../images/progress24.gif" />');
				//サマリーアイコン
				var summaryIcon = tableBody.find('.summaryIcon');
				summaryIcon.empty();
				if(objInstanceSummary.objectMapList['disconnectComputer'] == 'true'){
					summaryIcon.append('<img src="'+iconImgSrcTable['disconnectComputer'] + '" title="' + toolTipTable['disconnectComputer'] + '" alt="" />');
				}else if(objInstanceSummary.objectMapList['disconnectHelper'] == 'true'){
					summaryIcon.append('<img src="'+iconImgSrcTable['disconnectHelper'] + '" title="' + toolTipTable['disconnectHelper'] + '" alt="" />');
				}else if(objInstanceSummary.objectMapList['disconnectAgent'] == 'true'){
					summaryIcon.append('<img src="'+iconImgSrcTable['disconnectAgent'] + '" title="' + toolTipTable['disconnectAgent'] + '" alt="" />');
				}else if(objInstanceSummary.objectMapList['failure'] > 0){
					summaryIcon.append('<img src="'+iconImgSrcTable['failure'] + '" title="' + toolTipTable['failure'] + '" alt="" />');
				}else if(objInstanceSummary.objectMapList['danger'] > 0){
					summaryIcon.append('<img src="'+iconImgSrcTable['danger'] + '" title="' + toolTipTable['danger'] + '" alt="" />');
				}else if(objInstanceSummary.objectMapList['warning'] > 0){
					summaryIcon.append('<img src="'+iconImgSrcTable['warning'] + '" title="' + toolTipTable['warning'] + '" alt="" />');
				}else if(objInstanceSummary.objectMapList['normal'] > 0){
					summaryIcon.append('<img src="'+iconImgSrcTable['normal'] + '" title="' + toolTipTable['normal'] + '" alt="" />');
				}
				//失敗
				tableBody.find('.instanseStateFailure32').next('.value').get(0).innerText = objInstanceSummary.objectMapList['failure'];
				//危険
				tableBody.find('.instanseStateDanger32').next('.value').get(0).innerText = objInstanceSummary.objectMapList['danger'];
				//注意
				tableBody.find('.instanseStateWarning32').next('.value').get(0).innerText = objInstanceSummary.objectMapList['warning'];
				//正常
				tableBody.find('.instanseStateSuccess32').next('.value').get(0).innerText = objInstanceSummary.objectMapList['normal'];

				//ステータステーブル絡みの参照をクリア
				summaryIcon = null;
				tableBody = null;

				//ポーリング情報
				var tableBody = $('#pollingSettingTable');
				var tableTdList = tableBody.find('td');
				var nextPollingDate = objInstanceSummary.objectMapList['nextPollingDate'];
				var tdIndex = 1;
				//次回ポーリング日時
				if(objInstanceSummary.objectMapList['pollingEnable'] != 'true'){
					nextPollingDate = '';
				}
				tableTdList.eq(tdIndex).get(0).innerText = nextPollingDate;
				tdIndex = tdIndex+2;
				//最終ポーリング日時
				tableTdList.eq(tdIndex).get(0).innerText = objInstanceSummary.objectMapList['lastPollingDate'];
				tdIndex = tdIndex+2;
				//ポーリング実行状態～ポーリング間隔
				var duringPollingExecute = '実行中ではない';
				if(objInstanceSummary.objectMapList['duringPollingExecute'] == 'true'){
					duringPollingExecute = '実行中';
				}
				var pollingExtend = 'グループの設定に従う';
				var pollingEnable = '--';
				var pollingInterval = objInstanceSummary.objectMapList['pollingInterval'];
				if(objInstanceSummary.objectMapList['pollingExtend'] == 'true'){
					pollingExtend = '個別のポーリング設定を行う';
					if(objInstanceSummary.objectMapList['pollingEnable'] == 'true'){
						pollingEnable = '有効';
					}else{
						pollingEnable = '無効';
						doPollingFlag = false;
						pollingInterval = '--';  //ポーリング設定が無効の場合には、ポーリング間隔は表示しない
					}
					if( pollingInterval != '--' ){
						pollingInterval = (Number(pollingInterval)/60).toFixed()+'分';
					}
				}else{
					//ポーリング設定が「グループに従う」場合、他のポーリング設定は「--」表示とする
					if(objInstanceSummary.objectMapList['pollingEnable'] != 'true'){
						doPollingFlag = false;
					}
					pollingEnable = '--';
					pollingInterval = '--';
				}
				//実行中の場合には読み込み中アイコンも表示する
				tableTdList.eq(tdIndex).empty();
				if(objInstanceSummary.objectMapList['duringPollingExecute'] == 'true'){
					tableTdList.eq(tdIndex).append($('<span>'+duringPollingExecute+'</span>')).append(loadingIcon);
					$('#duringPollingExecuteFlag').val('true');
				}else{
					tableTdList.eq(tdIndex).append($('<span>'+duringPollingExecute+'</span>'));
					$('#duringPollingExecuteFlag').val('false');
				}
				tdIndex = tdIndex+2;
				tableTdList.eq(tdIndex).get(0).innerText = pollingExtend;
				tdIndex = tdIndex+2;
				tableTdList.eq(tdIndex).get(0).innerText = pollingEnable;
				tdIndex = tdIndex+2;
				tableTdList.eq(tdIndex).get(0).innerText = pollingInterval;
				tdIndex = tdIndex+2;
				//ポーリング情報絡みの参照をクリア
				tableTdList = null;
				tableBody = null;

				//インスタンス設定
				var tableBody = $('#instanceSettingTable');
				var tableTdList = tableBody.find('td');
				var tdIndex = 1;
				//表示名
				tableTdList.eq(tdIndex).get(0).innerText = objInstanceSummary.objectMapList['name'];
				tdIndex = tdIndex+2;
				//監視対象コンビューター
				tableTdList.eq(tdIndex).get(0).innerText = objInstanceSummary.objectMapList['computerName'];
				tdIndex = tdIndex+2;
				//ヘルパーサービスポート
				tableTdList.eq(tdIndex).get(0).innerText = objInstanceSummary.objectMapList['helperPort'];
				tdIndex = tdIndex+2;
				//インスタンス種別
				tableTdList.eq(tdIndex).addClass(objInstanceSummary.iconHashTable[objInstanceSummary.objectMapList['instanceType']]).css('padding-left','32px').get(0).innerText = objInstanceSummary.instanceNameHashTable[objInstanceSummary.objectMapList['instanceType']];
				tdIndex = tdIndex+2;
				//インスタンス名
				tableTdList.eq(tdIndex).get(0).innerText = objInstanceSummary.objectMapList['instanceName'];
				tdIndex = tdIndex+2;

				//「ただちにポーリングを行う」ボタンの有効 or 無効化
				if(doPollingFlag == false){
					$('#doPolling').attr('disabled', 'disabled');
					$('#doPolling').css('cursor', 'auto');
				}else{
					$('#doPolling').removeAttr('disabled');
					$('#doPolling').css('cursor', 'pointer');
				}
				//インスタンス設定絡みの参照をクリア
				tableTdList = null;
				tableBody = null;
			}else{
				var tableBody = $('#summaryStatusTable');
				var tableTdList = null;
				var tdIndex = 0;
				//サマリーアイコンの消去
				tableBody.find('.summaryIcon').empty();
				//失敗
				tableBody.find('.instanseStateFailure32').next('.value').get(0).innerText = '';
				//危険
				tableBody.find('.instanseStateDanger32').next('.value').get(0).innerText = '';
				//注意
				tableBody.find('.instanseStateWarning32').next('.value').get(0).innerText = '';
				//正常
				tableBody.find('.instanseStateSuccess32').next('.value').get(0).innerText = '';
				//ステータステーブル絡みの参照をクリア
				tableBody = null;

				//ポーリング情報
				tableBody = $('#pollingSettingTable');
				tdIndex = 1;
				//次回ポーリング日時
				tableBody.find('#nextPollingDate').get(0).innerText = '';
				//最終ポーリング日時
				tableBody.find('#lastPollingDate').get(0).innerText = '';
				//ポーリング実行状態
				tableBody.find('#duringPollingExecute span').get(0).innerText = '';
				//ポーリング設定
				tableBody.find('#pollingExtend').get(0).innerText = '';
				//ポーリング設定有効
				tableBody.find('#pollingEnable').get(0).innerText = '';
				//ポーリング間隔
				tableBody.find('#pollingInterval').get(0).innerText = '';

				//ポーリング情報絡みの参照をクリア
				tableBody = null;

				//インスタンス設定
				tableBody = $('#instanceSettingTable');
				tableTdList = tableBody.find('td');
				tdIndex = 1;
				//表示名
				tableTdList.eq(tdIndex).get(0).innerText = '';
				tdIndex = tdIndex+2;
				//監視対象コンビューター
				tableTdList.eq(tdIndex).get(0).innerText = '';
				tdIndex = tdIndex+2;
				//ヘルパーサービスポート
				tableTdList.eq(tdIndex).get(0).innerText = '';
				tdIndex = tdIndex+2;
				//インスタンス種別
				tableTdList.eq(tdIndex).get(0).innerText = '';
				tableTdList.eq(tdIndex).removeClass().addClass('value');
				tdIndex = tdIndex+2;
				//インスタンス名
				tableTdList.eq(tdIndex).get(0).innerText = '';
				tdIndex = tdIndex+2;
				//インスタンス設定絡みの参照をクリア
				tableTdList = null;
				tableBody = null;

				//ただちにポーリングを実行するボタンの無効化
				$('#doPolling').attr('disabled', 'disabled');
				$('#doPolling').css('cursor', 'auto');
			}
		}finally{
			$('body').removeData('refresh');
            //Loading終了
		    $('body').deleteLoadingScreen();
		}
	};

	//=========================================================================
	// 初回実行時の処理
	//=========================================================================
	objInstanceSummary.ajaxInstanceSummaryRequest();

	//=========================================================================
	// 「編集」ボタンクリック時の処理
	//=========================================================================
	$('#instanceEdit').click(function(){
		//インスタンス編集ダイアログを表示する
		top.showDialog('instance/instanceView.html?edited=false&instanceId='+$('#instanceId').val(), 'インスタンスの編集');
	});

	//オートリフレッシュタイマー開始
	$('#autoRefreshIntervalCount').val(0);
	objInstanceSummary.intervalTimerId = setInterval(autoRefreshTimer, 1000);
});

//=============================================================================
//子要素の取得応答
//=============================================================================
function detailsInstance_instanceSummaryAction_ajaxInstanceSummary(objectMapList) {
	//受信データ設定
	objInstanceSummary.ajaxInstanceSummaryResponse(objectMapList);
	//ページ表示の更新
	objInstanceSummary.pageUpdate();
	//リフレッシュ終了情報を設定する
	top.window.windowRefreshEnd('detailView');
}

//=============================================================================
//インスタンスサマリーのリフレッシュ処理要求
//=============================================================================
function windowRefresh(){
	$('body').data('refresh', true);
	//インスタンスサマリー情報取得要求
	objInstanceSummary.ajaxInstanceSummaryRequest();
}

//=============================================================================
//詳細ビューのリフレッシュ画面強制消去
//=============================================================================
function forceWindowRefreshEnd(){
	//リフレッシュ中フラグを消去
	if($('body').data('refresh') == true){
		$('body').removeData('refresh');
	}
	//自動更新用のタイマーを停止する
	clearInterval(objInstanceSummary.intervalTimerId);
	//処理中画面消去
	$('body').deleteLoadingScreen();
	//リフレッシュ終了情報を設定する
	top.window.windowRefreshEnd('detailView');
}

//=============================================================================
//オートリフレッシュ処理
//=============================================================================
function autoRefreshTimer(){
	if( $('#operationMode', top.document).val() != 'maintenance' ){
		var count = parseInt($('#autoRefreshIntervalCount').val());
		var autoRefreshTime = parseInt($('#autoRefreshInterval', top.document).val());
		count = count+1;
		//ポーリング実行中の場合には、15間隔でリフレッシュを行う
		if($('#duringPollingExecuteFlag').val() == 'true'){
			count = count<autoRefreshTime-15?autoRefreshTime-15:count;
		}

		if(count >= autoRefreshTime){
			if($('body').data('refresh') != true){
				windowRefresh();
				count = 0;
			}
			//ポーリング実行中の場合には、15間隔でリフレッシュを行う
			if($('#duringPollingExecuteFlag').val() == 'true'){
				count = autoRefreshTime-15;
			}
		}

		//時間を保存する
		$('#autoRefreshIntervalCount').val(count);
	}
}

//=============================================================================
//ajaxTimeout処理
//=============================================================================
function ajaxTimeout(){
	//リフレッシュ中フラグを消去
	if($('body').data('refresh') == true){
		$('body').removeData('refresh');
	}
	//処理中画面消去
	$('body').deleteLoadingScreen();
	//リフレッシュ終了情報を設定する
	top.window.windowRefreshEnd('detailView');
}
