//*****************************************************************************
// Copyright (C) 2013 SAY Technologies, Inc. All rights reserved.
//*****************************************************************************
$(document).ready(function() {
	$('#doFileDownload').click(function () {
		//IE8の場合、要素がない
		if( $('#allMessages').length > 0 ){
			$('#allMessages').get(0).innerText = '';
		}
	});
	var useragent= navigator.userAgent;
	if(useragent.search(/iPad/) != -1){
		//ダイアログの高さを設定する
		$('div.dialogBody').height($(top.document).find('#indicatorDialog').height()-$('div.dialogButtons').outerHeight(false)-10);
	}

	// ターゲット種別変更時
	$('#targetType').change(function () {
		// グループ以外選択時アクションログを選択不可
		if ($(this).val() != 'GROUP') {
			$('#logType option[value=ACTION_LOG]').attr('disabled', 'disabled');
		} else {
			$('#logType option[value=ACTION_LOG]').removeAttr('disabled');
		}

		// オートコンプリート クリアー
		$('#targetPath').autocomplete({
			source: []
		});

		// ターゲットオートコンプリート取得
		var ajaxParam = {'AjaxParam0' : $(this).val()};
		ajaxParam.onFailure = onAjaxFailure;
		Kumu.Ajax.executeTeedaAjax(logFileOutput_logFileOutputAction_ajaxTargetAutoCompleteCandidate, ajaxParam, Kumu.Ajax.RESPONSE_TYPE_JSON);
	});
	$('#targetType').change();
	//オートコンプリートの表示が横にずれる問題の対策
	//<body>の幅をそのwindowの幅に設定する
	$('body').width($(window).width());
});

//Ajaxコールバック関数
function logFileOutput_logFileOutputAction_ajaxTargetAutoCompleteCandidate(autoCompleteCandidate) {
	if (autoCompleteCandidate.length > 0) {
		$('#targetPath').autocomplete({
			source: autoCompleteCandidate,
			delay : 50,
			minLength : 0
		});
	}
}
