//*****************************************************************************
// Copyright (C) 2013-2014 SAY Technologies, Inc. All rights reserved.
//*****************************************************************************
$(document).ready(function(){
	// タブクリック時にリンク先URI設定
	$('li','#treeViewForm').click(function(){
		var clickPage = $(this).parents('.tabs').children('div').eq($(this).index()).children();
		clickPage.attr('src', clickPage.attr('id') + '.html');
	});

	// タブ化
	var tabIndex = $('#tabIndex').val();
	tabIndex = (tabIndex == undefined) ? 0 : tabIndex;
	$('div.tabs').simpleTabs({ 'tabIndex' : Number(tabIndex) });
	$(window).resize(function(){
		var thisTabsForm = $('#treeViewForm');
		var tabNavigator = thisTabsForm.find('ul.tabsNavigator');
		thisTabsForm.find('div.tab').each(function(){
			var thisTab = $(this);
			var thisTabHeight = $(window).innerHeight() - $('#mainLogview').outerHeight(false) - $('#mainCommandBar').outerHeight(false) - tabNavigator.outerHeight(false);
			thisTab.offset({top: $('#mainCommandBar').outerHeight(false) + tabNavigator.outerHeight(false)});
			thisTab.height(thisTabHeight);
		});
	});
	//画面のサイズが変更になった時の処理
	//スプリットバーが移動してもイベントを発生させている
	$(window).resize(function(){
		$('ul.tabsNavigator').width( $('body').width() );
	});
	$(window).resize();

	$(window).unload(function() {
		//iPadではないブラウザの場合全要素を消去する
		if(navigator.userAgent.search(/iPad/) == -1){
			$('*').remove();
		}
	});
});

//=============================================================================
//ツリービューのリフレッシュ処理
//=============================================================================
function windowRefresh(){
	var visibleTab = undefined;

	//表示中のタブを取得する
	$('div.tab').each(function(){
		if($(this).css('visibility')=='visible'){
			visibleTab = $(this);
		}
	});

	if(visibleTab != undefined){
		//自分が表示しているウィンドウのリフレッシュ処理を呼び出す
		var windowObject = $('iframe', visibleTab).get(0).contentWindow;
		if(windowObject.windowRefresh != undefined){
			windowObject.windowRefresh();
		}
	}
}

//=============================================================================
//ツリービューのリフレッシュ画面強制消去
//=============================================================================
function forceWindowRefreshEnd(){
	var visibleTab = undefined;

	//表示中のタブを取得する
	$('div.tab').each(function(){
		if($(this).css('visibility')=='visible'){
			visibleTab = $(this);
		}
	});

	if(visibleTab != undefined){
		//自分が表示しているウィンドウのリフレッシュ処理を呼び出す
		var windowObject = $('iframe', visibleTab).get(0).contentWindow;
		if(windowObject.forceWindowRefreshEnd != undefined){
			windowObject.forceWindowRefreshEnd();
		}
	}
}

