
from app import datetime_now_aware

class SystemCalendar:
    """システムカレンダークラス

    システムカレンダー制御用

    """
    def __init__(self):
        """初期化処理

        インスタンスを初期化する

        """
        self.current = datetime_now_aware()

    def is_holiday(self) -> bool:
        """休日判定

        現在日時が休日か判定する

        Return
        ------
        bool
            休日の場合、True
        """
        result = False

        # TODO 要実装
        if self.current.weekday() == 6:
            # 日曜日
            result = True

        return result

    def is_workday(self) -> bool:
        """平日判定

        現在日時が平日か判定する

        Return
        ------
        bool
            平日の場合、True
        """
        return not self.is_holiday()

