//*****************************************************************************
// Copyright (C) 2013-2014 SAY Technologies, Inc. All rights reserved.
//*****************************************************************************

var lastDateTime;
var intervalTimerId;

$(document).ready(function(){
	//=========================================================================
	// 「全チェック＆全ポーリング」クリック時の処理
	//=========================================================================
	$('#iconAllCheckAndPolling').on('click', function(e) {
		if (window.confirm("■警告■\n\n全インスタンスのステータスを確認済みにし、全インスタンスのポーリングを開始します。\n\nインスタンス数、または、インスタンスステータスログの確認状況によって処理時間がかかる場合があります。\n\n開始しますか？") != true ) {
			return false;
		}

		//処理中表示
		//ローディング表示の消去
		top.window.mainscreenViewLoading('全インスタンスステータス確認処理中＆ポーリング開始中');
		//ローディングのテキストを太文字にする
		$(top.document).find('div.blockMsg').css('font-weight', 'bold');


		$.get('/Indicator/view/teeda.ajax', {'component' : 'commandBar_commandBarAction', 'action' : 'ajaxAllInstanceStatusCheckAndPolling'}, commandBar_commandBarAction_ajaxAllInstanceStatusCheckAndPolling, null)
		.fail(function(jqXHR, textStatus, errorThrown ){
			//ローディング表示の消去
			top.window.mainscreenViewLoadingClear();
			top.window.mainscreenViewServerDown();
			top.window.forceAllWindowRefreshEnd();
		});
		return false;
	});
	//=========================================================================
	// 「更新」クリック時の処理
	//=========================================================================
	$('#iconRefresh').on('click', function(e) {
		//全Window更新処理を行う
		top.updateAllWindow();
		return false;
	});

	//=========================================================================
	// 「設定変更」クリック時の処理
	//=========================================================================
	$('#iconSystemConfig').on('click', function(e) {
		//インポートダイアログを表示する
		window.parent.showDialog('config/configuration.html', '設定変更', 720, 540);
		return false;
	});

	//=========================================================================
	// 「ログアウト」クリック時の処理
	//=========================================================================
	$('#iconLogout').on('click', function(e) {
		//ログアウト
		window.parent.location.href = '../logout.html';
		return false;
	});

	//=========================================================================
	// 「グループ編集」クリック時の処理
	//=========================================================================
	$('#iconGroup').on('click', function(e) {
		var mainCurentType = $('#curentType', top.document);
		var mainCurentId = $('#curentId', top.document);
		var mainCurentParentGroupId = $('#curentParentGroupId', top.document);
		var groupId = '';

		if(mainCurentType.val()=='GROUP'){
			groupId = mainCurentId.val();
		}else{
			groupId = mainCurentParentGroupId.val();
		}
		//グループ編集ダイアログを表示する
		window.parent.showDialog('group/groupView.html?groupId=' + groupId +'&edited=false', 'グループの編集');
		return false;
	});

	//=========================================================================
	// 「インスタンス編集」クリック時の処理
	//=========================================================================
	$('#iconInstance').on('click', function(e) {
		var mainCurentType = $('#curentType', top.document);
		var mainCurentId = $('#curentId', top.document);
		var uri = "instance/instanceView.html?edited=false";
		if(mainCurentType.val()=='GROUP'){
			// カレントはグループ
			uri += '&groupId=' + mainCurentId.val();
		} else {
			// カレントはインスタンス
			uri += '&instanceId=' + mainCurentId.val();
		}
		//インスタンス編集ダイアログを表示する
		window.parent.showDialog(uri, 'インスタンスの編集');
		return false;
	});

	//=========================================================================
	// 「アクション編集」クリック時の処理
	//=========================================================================
	$('#iconAction').on('click', function(e) {
		var mainCurentType = $('#curentType', top.document);
		var mainCurentId = $('#curentId', top.document);
		var mainCurentParentGroupId = $('#curentParentGroupId', top.document);
		var targetId = '';
		//グループ選択中ならカレントグループのIDを設定し、インスタンス選択中なら親のグループIDを設定する
		if( mainCurentType.val() == 'GROUP' ){
			targetId = mainCurentId.val();
		}else{
			targetId = mainCurentParentGroupId.val();
		}
		//アクション編集ダイアログを表示する
		window.parent.showDialog('action/actionList.html?groupId=' + targetId +'&edited=false', 'アクションの編集');
		return false;
	});

	//=========================================================================
	// 「インポート」クリック時の処理
	//=========================================================================
	$('#iconImport').click(function() {
		//インポートダイアログを表示する
		window.parent.showDialog('dataPump/import.html', 'インポート');
		return false;
	});

	//=========================================================================
	// 「エクスポート」クリック時の処理
	//=========================================================================
	$('#iconExport').on('click', function(e) {
		//エクスポートダイアログを表示する
		window.parent.showDialog('dataPump/export.html', 'エクスポート');
		return false;
	});

	//=========================================================================
	// 「ファイル出力」クリック時の処理
	//=========================================================================
	$('#iconLogFileOutput').on('click', function(e){
		var mainCurentType = $('#curentType', top.document);
		var mainCurentId = $('#curentId', top.document);
		//ファイル出力ダイアログを表示する
		window.parent.showDialog('logFileOutput/logFileOutput.html?currentType=' + mainCurentType.val() + '&currentId=' + mainCurentId.val(), 'ログファイル出力');
		return false;
	});

	//=========================================================================
	// 「インスタンス情報収集」クリック時の処理
	//=========================================================================
	$('#iconCollectInstanceData').on('click', function(e){
		window.parent.showDialog('gatheringInstance/gatheringChoseComputer.html', 'インスタンス情報収集', 640, 600);
		return false;
	});

	//=========================================================================
	// 「ユーザー管理」クリック時の処理
	//=========================================================================
	$('#iconUserManager').click(function() {
		//ユーザー管理ダイアログを表示する
		window.parent.showDialog('user/userList.html', 'ユーザー管理');
		return false;
	});

	//=========================================================================
	// 「システムログ表示」クリック時の処理
	//=========================================================================
	$('#iconSystemLog').on('click', function(e) {
		//システムログを表示する
		window.parent.showDialog('systemLog/systemLogViewer.html', 'システムログ表示', 800, 600, true);
		return false;
	});

	//=========================================================================
	// 「上へ」クリック時の処理
	//=========================================================================
	$('#iconGoUp').on('click', function(e) {
		var parentGroupId = $('#curentParentGroupId', top.document).val();
		//rootの時にはページ遷移しない
		if(parentGroupId != ''){
			//上のパスへアクセスする
			var srcString = 'detailsGroup/detailsGroup.html?groupId=' + parentGroupId;
			//ページ遷移をする
			$('#mainDetails', top.document).attr('src', srcString);
		}
		return false;
	});

	//=========================================================================
	// 「戻る」クリック時の処理
	//=========================================================================
	$('#iconPrevious').on('click', function(e) {
		//上のパスへアクセスする
		var srcString = top.pageNavigatePop();
		if(srcString != ''){
			//ページ遷移をする
			$('#mainDetails', top.document).attr('src', srcString);
		}
		return false;
	});

	//=========================================================================
	// アドレスバーでキー押下時の処理
	//=========================================================================
	$('#address').on('keydown', function(e){
		if (e.which == 13) {
//			var ajaxParam = {'AjaxParam0' : $(this).val()};
//			ajaxParam.onFailure = onAjaxFailure;
//			Kumu.Ajax.executeTeedaAjax(commandBar_commandBarAction_ajaxId, ajaxParam, Kumu.Ajax.RESPONSE_TYPE_JSON);
			$.get('/Indicator/view/teeda.ajax', {'component' : 'commandBar_commandBarAction', 'action' : 'ajaxId', 'AjaxParam0' : $(this).val()}, commandBar_commandBarAction_ajaxId, 'json');
			return false;
		}
	});

	//=========================================================================
	// 「ライセンスチェック」クリック時の処理
	//=========================================================================
	$('#iconLicenseCheck').on('click', function(e) {
		window.parent.showDialog('licenseCheck/licenseCheckViewer.html', 'ライセンスチェック', 920, 600, true);
		return false;
	});


	//=========================================================================
	// 「メール受信設定」クリック時の処理
	//=========================================================================
	$('#iconMailSetting').on('click', function(e) {
		var mainCurentType = $('#curentType', top.document);
		var mainCurentId = $('#curentId', top.document);
		var uri = "mail/mailList.html?";
		if(mainCurentType.val()=='GROUP'){
			// カレントはグループ
			uri += 'groupId=' + mainCurentId.val();
		} else {
			// カレントはインスタンス
			uri += 'instanceId=' + mainCurentId.val();
		}
		window.parent.showDialog(uri, 'メール受信設定');
		return false;
	});


	//=========================================================================
	// アプリケーションウィンドウリサイズ時の処理
	//=========================================================================
	$(window).resize(function () {
		if($(this).width()<500){
			$('#upperRow').width(500-5);
			$('#address').width($('#upperRow').width() - $('#navigations').width()- $('#icons1').width() - $('#icons3').width() - 120);
		}else{
			$('#upperRow').width($(this).width()-5);
			$('#address').width($('#upperRow').width() - $('#navigations').width()- $('#icons1').width() - $('#icons3').width() - 120);
		}
	});

	//=========================================================================
	// メイン処理
	//=========================================================================
	//サーバー時刻取得要求送信
//	var ajaxParam = {};
//	ajaxParam.onFailure = onAjaxFailure;
//	Kumu.Ajax.executeTeedaAjax(commandBar_commandBarAction_ajaxServerTime, ajaxParam, Kumu.Ajax.RESPONSE_TYPE_TEXT);
	$.get('/Indicator/view/teeda.ajax', {'component' : 'commandBar_commandBarAction', 'action' : 'ajaxServerTime'}, commandBar_commandBarAction_ajaxServerTime, 'text');
	//タイマー開始
	var timerId = setInterval(timerSet, 1000);
	$('#serverTime').data('timerId', timerId);

	//オートコンプリート情報取得要求
//	var ajaxParam = {};
//	ajaxParam.onFailure = onAjaxFailure;
//	Kumu.Ajax.executeTeedaAjax(commandBar_commandBarAction_ajaxAutoCompleteCandidate, ajaxParam, Kumu.Ajax.RESPONSE_TYPE_JSON);
	$.get('/Indicator/view/teeda.ajax', {'component' : 'commandBar_commandBarAction', 'action' : 'ajaxAutoCompleteCandidate'}, commandBar_commandBarAction_ajaxAutoCompleteCandidate, 'json');

	//ボタンの表示を切り替える
	if($(top.document).find('#permissionWrite').val() != 'true'){
		$('.icons').children('button.permissionWrite').remove();
	}
	var useragent= navigator.userAgent;
	if(useragent.search(/iPad/) != -1){
		//iPadは、インポート・エクスポート・ログファイル出力を行えないようにする
		$('#iconImport').remove();
		$('#iconExport').remove();
		$('#iconLogFileOutput').remove();
	}

	$('.icons,#navigations').children('button').each(function(){
		var thisButton = $(this);

		thisButton.button({
			icons:{primary:thisButton.val()},
			text: true});
	});

	//画面のリサイズを行う
	$(window).resize();

	//オートリフレッシュタイマー開始
	$('#autoRefreshIntervalCount').val(0);
	intervalTimerId = setInterval(autoRefreshTimer, 1000);

	//インターバルタイマーを停止する
	$(window).unload(function() {
		clearInterval(intervalTimerId);
		//iPadではないブラウザの場合全要素を消去する
		if(navigator.userAgent.search(/iPad/) == -1){
			$('*').remove();
		}
	});
});

// グローバル関数
//=========================================================================
// アドレスバー設定要求
//=========================================================================
function setCommandBarAddress(targetType, targetId) {
	//アドレスバー設定情報取得要求
//	var ajaxParam = {'AjaxParam0' : targetType, 'AjaxParam1' : targetId};
//	ajaxParam.onFailure = onAjaxFailure;
//	Kumu.Ajax.executeTeedaAjax(commandBar_commandBarAction_ajaxPath, ajaxParam, Kumu.Ajax.RESPONSE_TYPE_TEXT);
	$.get('/Indicator/view/teeda.ajax', {'component' : 'commandBar_commandBarAction', 'action' : 'ajaxPath', 'AjaxParam0' : targetType, 'AjaxParam1' : targetId}, commandBar_commandBarAction_ajaxPath, 'text');
}

//Ajaxコールバック関数
//=========================================================================
// オートコンプリート情報取得応答
//=========================================================================
function commandBar_commandBarAction_ajaxAutoCompleteCandidate(autoCompleteCandidate) {
	if (autoCompleteCandidate.length > 0) {
		$('#address').autocomplete({
			source : autoCompleteCandidate,
			delay : 50,
			minLength : 0
		});
	}
}

//=========================================================================
//コマンドバーアドレス入力応答
//=========================================================================
function commandBar_commandBarAction_ajaxId(objectMap) {
	//対応ページがない場合には、nullが設定されている。
	//その場合には、ページ遷移を行わない
	if( objectMap === null ){
		return;
	}
	var type = objectMap['type'];
	var targetId = objectMap['id'];



	$('#type').val(objectMap['type']);
	$('#id').val(objectMap['id']);

	//データ種別毎に処理を分ける
	if(type == 'GROUP'){
		var srcString = 'detailsGroup/detailsGroup.html?groupId=' + targetId;
		if( srcString != $('#mainDetails', top.document).attr('src') ){
			//ページ遷移をする
			$('#mainDetails', top.document).attr('src', srcString);
		}else{
			//詳細ページをリフレッシュする
			top.mainDetails.windowRefresh();
		}
	}else{
		var srcString = 'detailsInstance/detailsInstance.html?instanceId=' + targetId;
		if( srcString != $('#mainDetails', top.document).attr('src') ){
			//ページ遷移をする
			$('#mainDetails', top.document).attr('src', srcString);
		}else{
			//詳細ページをリフレッシュする
			top.mainDetails.windowRefresh();
		}
	}
}

//=========================================================================
// アドレスバー設定情報取得応答
//=========================================================================
function commandBar_commandBarAction_ajaxPath(addressPath) {
	//アドレスバー情報を設定する
	$('#address').val(addressPath);
}

//=========================================================================
// 全ステータスのチェック＆ポーリング処理完了のコールバック
//=========================================================================
function commandBar_commandBarAction_ajaxAllInstanceStatusCheckAndPolling(){
	//ローディング表示の消去
	top.window.mainscreenViewLoadingClear();
}

//=========================================================================
//サーバー時刻取得応答
//=========================================================================
var localtime;
var lastDateTime;
function commandBar_commandBarAction_ajaxServerTime(serverTime) {
	//サーバー時刻を保存する
	localtime = parseInt(serverTime)*1000;//ミリ秒単位に変換
	//最終システム時刻を取得する
	lastDateTime = (new Date()).getTime();

	$('body').removeData('refresh');
	//リフレッシュ終了情報を設定する
	top.window.windowRefreshEnd('commandBar');
}
//=========================================================================
// 時刻設定用の関数
//=========================================================================
function timerSet(){
	if(localtime == undefined){
		return;
	}
	//前回取得のシステム時刻と今回取得のシステム時刻の差分を加算する
	var nowDateTime = (new Date()).getTime();
	localtime += nowDateTime - lastDateTime;
	lastDateTime = nowDateTime;

	var time = new Date(localtime);
	var timeString = ( '0' + time.getHours() ).slice( -2 ) + ':' + ( '0' + time.getMinutes() ).slice( -2 ) + ':' + ( '0' + time.getSeconds() ).slice( -2 );
	$('#serverTime').html(timeString);
}

//=============================================================================
// コマンドバービューのリフレッシュ処理要求
//=============================================================================
function windowRefresh(){
	$('body').data('refresh', true);
	//サーバー時刻取得要求送信
	//var ajaxParam = {};
	//ajaxParam.onFailure = onAjaxFailure;
	//Kumu.Ajax.executeTeedaAjax(commandBar_commandBarAction_ajaxServerTime, ajaxParam, Kumu.Ajax.RESPONSE_TYPE_TEXT);
	$.get('/Indicator/view/teeda.ajax', {'component' : 'commandBar_commandBarAction', 'action' : 'ajaxServerTime'}, commandBar_commandBarAction_ajaxServerTime, 'text')
		.fail(function(jqXHR, textStatus, errorThrown ){
			top.window.mainscreenViewServerDown();
			top.window.forceAllWindowRefreshEnd();
		});

	//オートコンプリート取得要求
	$.get('/Indicator/view/teeda.ajax', {'component' : 'commandBar_commandBarAction', 'action' : 'ajaxAutoCompleteCandidate'}, commandBar_commandBarAction_ajaxAutoCompleteCandidate, 'json');
}

//=============================================================================
//コマンドバービューのリフレッシュ画面強制消去
//=============================================================================
function forceWindowRefreshEnd(){
	//リフレッシュ中フラグを消去
	if($('body').data('refresh') == true){
		$('body').removeData('refresh');
	}
	//自動更新のタイマーを停止する
	clearInterval(intervalTimerId);
	//処理中画面消去
	$('body').deleteLoadingScreen();
	//リフレッシュ終了情報を設定する
	top.window.windowRefreshEnd('commandBar');
}

//=============================================================================
//オートリフレッシュ処理
//=============================================================================
function autoRefreshTimer(){
	if( $('#operationMode', top.document).val() != 'maintenance' ){
		var count = parseInt($('#autoRefreshIntervalCount').val());
		var autoRefreshTime = parseInt($('#autoRefreshInterval', top.document).val());
		count = count+1;

		if(count >= autoRefreshTime){
			if($('body').data('refresh') != true){
				windowRefresh();
				count = 0;
			}
		}

		//時間を保存する
		$('#autoRefreshIntervalCount').val(count);
	}
}

//=============================================================================
//ajaxTimeout処理
//=============================================================================
function ajaxTimeout(){
	//リフレッシュ中フラグを消去
	if($('body').data('refresh') == true){
		$('body').removeData('refresh');
	}
	//処理中画面消去
	$('body').deleteLoadingScreen();
	//リフレッシュ終了情報を設定する
	top.window.windowRefreshEnd('commandBar');
}
