//*****************************************************************************
// Copyright (C) 2017 SAY Technologies, Inc. All rights reserved.
//*****************************************************************************
$(document).ready(function(){
	var useragent= navigator.userAgent;
	if(useragent.search(/iPad/) != -1){
		//ダイアログの高さを設定する
		$('div.dialogBody').height($(top.document).find('#indicatorDialog').height()-$('div.dialogButtons').outerHeight(false)-10);
	}
	//=========================================================================
	// イベント処理
	//=========================================================================
	$('#doNext').click(function () {
		//ポート番号のチェック関数
		var portCheck = function(num){
			if(((1<=num)&&(num<=65535)) == false){
				return false;
			}
			return true;
		};

		//ターゲットは一つ以上選択しなければならない。
		var searchHit = false;
		var targetList = $('#bom5target,#bom6target,#bom7target,#bom8target');
		targetList.each(function(){
			if($(this).is(':checked')){
				searchHit = true;
			}
		});
		if(searchHit == false){
			alert('対象が選択されておりません。収集するインスタンスのBOMバージョンを選択してください');
			return false;
		}

		//選択しているターゲット内のデータチェックを行う
		var targetList = $('#bom5target,#bom6target,#bom7target,#bom8target');
		var funcRet = true;
		targetList.each(function(){
			if($(this).is(':checked')){
				if($(this).attr('id') == 'bom5target'){
					//-------------------------------------------------------------
					// ポート番号チェック
					//-------------------------------------------------------------
					if(portCheck($('#bom5port').val()) == false){
						alert('BOM 5.0のポート番号設定に不正な値があります。ご確認ください');
						funcRet = false;
					}
					//-------------------------------------------------------------
					// インスタンス種別チェック
					//-------------------------------------------------------------
					//インスタンス種別は一つ以上選択しなければならない。
					var instanceBom5TypeList = $('#bom5windows,#bom5linux,#bom5vmware');
					var searchBom5Hit = false;
					instanceBom5TypeList.each(function(){
						if($(this).is(':checked')){
							searchBom5Hit = true;
						}
					});
					if(searchBom5Hit == false){
						alert('BOM 5.0のインスタンス種別が選択されておりません。インスタンス種別を選択してください');
						funcRet = false;
					}
				}else if($(this).attr('id') == 'bom6target'){
					//-------------------------------------------------------------
					// ポート番号チェック
					//-------------------------------------------------------------
					if(portCheck($('#bom6port').val()) == false){
						alert('BOM 6.0のポート番号設定に不正な値があります。ご確認ください');
						funcRet = false;
					}
					//-------------------------------------------------------------
					// インスタンス種別チェック
					//-------------------------------------------------------------
					//インスタンス種別は一つ以上選択しなければならない。
					var instanceBom6TypeList = $('#bom6windows,#bom6linux,#bom6vmware');
					var searchBom6Hit = false;
					instanceBom6TypeList.each(function(){
						if($(this).is(':checked')){
							searchBom6Hit = true;
						}
					});
					if(searchBom6Hit == false){
						alert('BOM 6.0のインスタンス種別が選択されておりません。インスタンス種別を選択してください');
						funcRet = false;
					}
				}else if($(this).attr('id') == 'bom7target'){
					//-------------------------------------------------------------
					// ポート番号チェック
					//-------------------------------------------------------------
					if(portCheck($('#bom7port').val()) == false){
						alert('BOM 7.0のポート番号設定に不正な値があります。ご確認ください');
						funcRet = false;
					}
					//-------------------------------------------------------------
					// インスタンス種別チェック
					//-------------------------------------------------------------
					//インスタンス種別は一つ以上選択しなければならない。
					var instanceBom6TypeList = $('#bom7windows,#bom7linux,#bom7vmware');
					var searchBom6Hit = false;
					instanceBom6TypeList.each(function(){
						if($(this).is(':checked')){
							searchBom6Hit = true;
						}
					});
					if(searchBom6Hit == false){
						alert('BOM 7.0のインスタンス種別が選択されておりません。インスタンス種別を選択してください');
						funcRet = false;
					}
                }else if($(this).attr('id') == 'bom8target'){
                    //-------------------------------------------------------------
                    // ポート番号チェック
                    //-------------------------------------------------------------
                    if(portCheck($('#bom8port').val()) == false){
                        alert('BOM 8.0のポート番号設定に不正な値があります。ご確認ください');
                        funcRet = false;
                    }
                    //-------------------------------------------------------------
                    // インスタンス種別チェック
                    //-------------------------------------------------------------
                    //インスタンス種別は一つ以上選択しなければならない。
                    var instanceBom8TypeList = $('#bom8windows,#bom8linux,#bom8vmware');
                    var searchBom8Hit = false;
                    instanceBom8TypeList.each(function(){
                        if($(this).is(':checked')){
                            searchBom8Hit = true;
                        }
                    });
                    if(searchBom8Hit == false){
                        alert('BOM 8.0のインスタンス種別が選択されておりません。インスタンス種別を選択してください');
                        funcRet = false;
                    }
				}
			}
		});
		if(funcRet == false){
			return false;
		}
		//画面遷移中は他のボタンを効かないようにする
		// disabledを使用するとサーバーにデータが送られ無くなってしまうため、
		// クリックイベントを無視する方向に変更する
		$('div.dialogButtons').children('input').on('click', function(){
			return false;
		});
		return true;
	});

	$('#jumpGatheringChoseComputer').on('click', function(){
		//画面遷移中は他のボタンを効かないようにする
		// disabledを使用するとサーバーにデータが送られ無くなってしまうため、
		// クリックイベントを無視する方向に変更する
		$('div.dialogButtons').children('input').on('click', function(){
			return false;
		});
	});

	$('#bom5target').change(function () {
		if ($(this).attr('checked') == undefined) {
			$('#bom5port').attr('disabled', 'disabled');
			$('#bom5password').attr('disabled', 'disabled');
			$('#bom5windows').attr('disabled', 'disabled');
			$('#bom5linux').attr('disabled', 'disabled');
			$('#bom5vmware').attr('disabled', 'disabled');
		} else {
			$('#bom5port').removeAttr('disabled');
			$('#bom5password').removeAttr('disabled');
			$('#bom5windows').removeAttr('disabled');
			$('#bom5linux').removeAttr('disabled');
			$('#bom5vmware').removeAttr('disabled');
		}
	});
	$('#bom5target').change();

	$('#bom6target').change(function () {
		if ($(this).attr('checked') == undefined) {
			$('#bom6port').attr('disabled', 'disabled');
			$('#bom6password').attr('disabled', 'disabled');
			$('#bom6windows').attr('disabled', 'disabled');
			$('#bom6linux').attr('disabled', 'disabled');
			$('#bom6vmware').attr('disabled', 'disabled');
		} else {
			$('#bom6port').removeAttr('disabled');
			$('#bom6password').removeAttr('disabled');
			$('#bom6windows').removeAttr('disabled');
			$('#bom6linux').removeAttr('disabled');
			$('#bom6vmware').removeAttr('disabled');
		}
	});
	$('#bom6target').change();

	$('#bom7target').change(function () {
		if ($(this).attr('checked') == undefined) {
			$('#bom7port').attr('disabled', 'disabled');
			$('#bom7password').attr('disabled', 'disabled');
			$('#bom7windows').attr('disabled', 'disabled');
			$('#bom7linux').attr('disabled', 'disabled');
			$('#bom7vmware').attr('disabled', 'disabled');
		} else {
			$('#bom7port').removeAttr('disabled');
			$('#bom7password').removeAttr('disabled');
			$('#bom7windows').removeAttr('disabled');
			$('#bom7linux').removeAttr('disabled');
			$('#bom7vmware').removeAttr('disabled');
		}
	});
	$('#bom7target').change();

    $('#bom8target').change(function () {
        if ($(this).attr('checked') == undefined) {
            $('#bom8port').attr('disabled', 'disabled');
            $('#bom8password').attr('disabled', 'disabled');
            $('#bom8windows').attr('disabled', 'disabled');
            $('#bom8linux').attr('disabled', 'disabled');
            $('#bom8vmware').attr('disabled', 'disabled');
        } else {
            $('#bom8port').removeAttr('disabled');
            $('#bom8password').removeAttr('disabled');
            $('#bom8windows').removeAttr('disabled');
            $('#bom8linux').removeAttr('disabled');
            $('#bom8vmware').removeAttr('disabled');
        }
    });
    $('#bom8target').change();
});

