SELECT
	group_id,
	group_name,
	parent_group_id,
	group_polling_enabled,
	group_polling_interval,
	create_datetime,
	create_user_id,
	update_datetime,
	update_user_id,
	(SELECT user_name FROM user WHERE user_id = instance_group.create_user_id) AS create_user_name,
	(SELECT user_name FROM user WHERE user_id = instance_group.update_user_id) AS update_user_name
FROM
	instance_group
WHERE
	group_id = /*group_id*/
