SELECT
	instance_log_id,
	instance_log.instance_id,
	group_id,
	display_name,
	instance_kind,
	datetime,
	polling_status_disconnect_computer,
	polling_status_disconnect_helper,
	polling_status_disconnect_agent,
	failure_count,
	danger_count,
	warning_count,
	normal_count,
	confirm_status,
	outline_string
FROM
	instance_log
	LEFT OUTER JOIN
	instance
	ON (instance_log.instance_id = instance.instance_id)
/*BEGIN*/
WHERE
	/*IF instance_log_id_list != null && !instance_log_id_list.isEmpty*/instance_log_id IN /*instance_log_id_list*/(1,2)/*END*/
/*END*/
