SELECT
	mail_set_id,
	group_id,
	instance_id,
	display_name,
	computer_name,
	recv_service_port,
	user_name,
	password_encrypted,
	protocol_kind,
	polling_enabled,
	polling_interval,
	use_ssl,
	del_mail,
	last_poll_datetime,
	next_poll_datetime,
	during_execute,
	create_user_id,
	(SELECT user_name FROM user WHERE user_id = mail_setting.create_user_id) AS create_user_name,
	create_datetime,
	update_user_id,
	(SELECT user_name FROM user WHERE user_id = mail_setting.update_user_id) AS update_user_name,
	update_datetime
FROM
	mail_setting
