CREATE TABLE bom_history_log(
	bom_history_log_id				IDENTITY	PRIMARY KEY,
	instance_id						BIGINT		NOT NULL,
	datetime						TIMESTAMP	NOT NULL,
	type							INTEGER		NOT NULL,
	category						VARCHAR		NOT NULL,
	summary							VARCHAR		NOT NULL,
	message							VARCHAR		NOT NULL
);
CREATE INDEX index_bom_history_log_instanceid ON bom_history_log (
	instance_id
);
CREATE INDEX index_bom_history_log_datetime ON bom_history_log (
	datetime DESC
);
CREATE HASH INDEX index_bom_history_log_type_instance_id ON bom_history_log (
	type,
	instance_id
);
CREATE HASH INDEX index_bom_history_log_category_instance_id ON bom_history_log (
	category,
	instance_id
);