CREATE TABLE bom_recv_log(
	bom_recv_log_id					IDENTITY	PRIMARY KEY,
	recv_set_id						BIGINT		NOT NULL,
	bom_monitor_kind				INTEGER		NOT NULL,
	send_time						TIMESTAMP	NOT NULL,
	recv_time						TIMESTAMP	NOT NULL,
	message_id						VARCHAR,
	duration						DOUBLE,
	subject							VARCHAR,
	send_from						VARCHAR,
	message							VARCHAR,
	source							VARCHAR,
	status							INTEGER
);
CREATE UNIQUE INDEX index_bom_recv_log_1 ON bom_recv_log (
	message_id,
	send_time
);
CREATE INDEX index_bom_recv_log_2 ON bom_recv_log (
	recv_set_id,
	send_time
);

