CREATE TABLE instance_group(
	group_id						IDENTITY	PRIMARY KEY,
	group_name						VARCHAR		NOT NULL,
	parent_group_id					BIGINT,
	group_polling_enabled			BOOLEAN		NOT NULL,
	group_polling_interval			INTEGER		NOT NULL,
	create_datetime					TIMESTAMP	NOT NULL,
	create_user_id					VARCHAR		NOT NULL,
	update_datetime					TIMESTAMP	NOT NULL,
	update_user_id					VARCHAR		NOT NULL,
	UNIQUE(group_name, parent_group_id)
);
