CREATE TABLE instance(
	instance_id						IDENTITY	PRIMARY KEY,
	group_id						BIGINT		NOT NULL,
	display_name					VARCHAR		NOT NULL,
	computer_name					VARCHAR_IGNORECASE		NOT NULL,
	helper_service_port				INTEGER		NOT NULL,
	bom_user						VARCHAR		NOT NULL,
	bom_password_encrypted			VARCHAR		NOT NULL,
	instance_kind					VARCHAR		NOT NULL,
	instance_name					VARCHAR_IGNORECASE		NOT NULL,
	polling_extend					BOOLEAN		NOT NULL,
	polling_enabled					BOOLEAN		NOT NULL,
	polling_interval				INTEGER		NOT NULL,
	create_datetime					TIMESTAMP	NOT NULL,
	create_user_id					VARCHAR		NOT NULL,
	update_datetime					TIMESTAMP	NOT NULL,
	update_user_id					VARCHAR		NOT NULL,
	UNIQUE(group_id, display_name)
);
