CREATE TABLE mail_setting (
	mail_set_id						IDENTITY	PRIMARY KEY,
	group_id						BIGINT		NOT NULL DEFAULT -1,
	instance_id						BIGINT		NOT NULL DEFAULT -1,
	display_name					VARCHAR		NOT NULL,
	computer_name					VARCHAR_IGNORECASE		NOT NULL,
	recv_service_port				INTEGER		NOT NULL,
	user_name						VARCHAR		NOT NULL,
	password_encrypted				VARCHAR		NOT NULL,
	protocol_kind					VARCHAR		NOT NULL,
	polling_enabled					BOOLEAN		NOT NULL,
	polling_interval				INTEGER		NOT NULL,
	use_ssl							BOOLEAN		NOT NULL,
	del_mail						BOOLEAN		NOT NULL,
	last_poll_datetime				TIMESTAMP,
	next_poll_datetime				TIMESTAMP,
	during_execute					BOOLEAN,
	create_datetime					TIMESTAMP	NOT NULL,
	create_user_id					VARCHAR		NOT NULL,
	update_datetime					TIMESTAMP	NOT NULL,
	update_user_id					VARCHAR		NOT NULL
);
CREATE UNIQUE INDEX idx_mail_set_sub1 ON mail_setting (group_id, instance_id, display_name);
