/**** ZLeBiOCA[Uj ****/


USE [master]
GO
IF NOT EXISTS (SELECT name FROM master.dbo.syslogins WHERE name = N'bom6archivemgruser')
BEGIN
	EXECUTE sp_addlogin @loginame = N'bom6archivemgruser', 
		@passwd = 0x0100661B7C65F045AE8D06EFC7A24315A0CEBAA1D41392A467D3, 
		@defdb = N'bom6_archive', 
		@deflanguage = N'{', 
		@encryptopt = N'skip_encryption'
END
GO 


USE [master]
GO
IF EXISTS (SELECT name FROM master.dbo.sysdatabases WHERE name = N'bom6_archive')
BEGIN
	IF NOT EXISTS (SELECT name FROM bom6_archive..sysusers WHERE name = N'bom6archivemgruser' AND hasdbaccess = 1)
	BEGIN
		EXECUTE sp_executesql N'USE bom6_archive EXECUTE sp_grantdbaccess N''bom6archivemgruser'''
		IF EXISTS (SELECT name FROM bom6_archive..sysusers WHERE name = N'Bom6ArchiveMgr' AND issqlrole =1)
			EXECUTE sp_executesql N'USE bom6_archive EXECUTE sp_addrolemember N''Bom6ArchiveMgr'', N''bom6archivemgruser'''
	END
END
GO


USE [master]
GO
IF NOT EXISTS (SELECT name FROM master..sysusers WHERE name = N'bom6archivemgruser' AND hasdbaccess = 1)
	EXECUTE sp_executesql N'USE master EXECUTE sp_grantdbaccess N''bom6archivemgruser'''
GO


USE [master]
GO

IF NOT EXISTS (SELECT name FROM master.dbo.syslogins WHERE name = N'bom6archivesvcuser')
BEGIN
	EXECUTE sp_addlogin @loginame = N'bom6archivesvcuser', 
		@passwd = 0x0100EC5B333F4F1AC0B6A28F04AA199F2443EDD53DA8ADF1B47B, 
		@defdb = N'bom6_archive', 
		@deflanguage = N'{', 
		@encryptopt = N'skip_encryption'
END
GO


USE [master]
GO
IF EXISTS (SELECT name FROM master.dbo.sysdatabases WHERE name = N'bom6_archive')
BEGIN
	IF NOT EXISTS (SELECT name FROM bom6_archive..sysusers WHERE name = N'bom6archivesvcuser' AND hasdbaccess = 1)
	BEGIN
		EXECUTE sp_executesql N'USE bom6_archive EXECUTE sp_grantdbaccess N''bom6archivesvcuser'''
		IF EXISTS (SELECT name FROM bom6_archive..sysusers WHERE name = N'Bom6ArchiveSvc' AND issqlrole =1)
			EXECUTE sp_executesql N'USE bom6_archive EXECUTE sp_addrolemember N''Bom6ArchiveSvc'', N''bom6archivesvcuser'''
	END
END
GO

USE [msdb]
GO
IF NOT EXISTS (SELECT name FROM msdb..sysusers WHERE name = N'bom6archivemgruser' AND hasdbaccess = 1)
BEGIN
	EXECUTE sp_executesql N'USE msdb EXECUTE sp_grantdbaccess N''bom6archivemgruser'''
	EXECUTE sp_executesql N'USE msdb EXECUTE sp_addrolemember N''SQLAgentOperatorRole'', N''bom6archivemgruser'''
END
GO
