@echo off
setlocal
Rem ------------------------------------------------------------------------------------------------
Rem PersistentDataCob`
Rem 
Rem Copyright (C) 2022 SAY Technologies, Inc. All rights reserved.
Rem ŏICF2021/12/02
Rem 1FSRSID
Rem 2FSRS6\bin
Rem 3F$(PersistentDataDir)
Rem ------------------------------------------------------------------------------------------------

SET SRSID=%~1
SET SRSBIN=%~2
SET PERSISTENTDATA_PATH=%~3

REM --- T[rX̊mF ---
SET SERVICE_NAME=BOM8Agent$%SRSID%
IF %SERVICE_NAME%==BOM8Agent$ GOTO ERR_ARG

REM -- SRS6\bintH_̊mF
if not exist "%SRSBIN%" (
	ECHO u%SRSBIN%v݂܂B
	goto ERR_ARG
)

REM --- T[rX̒~ ---
NET STOP "%SERVICE_NAME%"

REM --- PersistentDataC̋N ---
"%SRSBIN%\PersistentDataRepair.exe" -c "repair" -per "%PERSISTENTDATA_PATH%" -erm 8

REM --- T[rX̊Jn ---
NET START "%SERVICE_NAME%"

GOTO END_RESTART

:ERR_ARG
ECHO "p[^G["
endlocal
@echo on
exit /b 1


:END_RESTART
endlocal
@echo on
exit /b 0
