//*****************************************************************************
// Copyright (C) 2013 SAY Technologies, Inc. All rights reserved.
//*****************************************************************************
$(document).ready(function() {
	var useragent= navigator.userAgent;
	if(useragent.search(/iPad/) != -1){
		//ダイアログの高さを設定する
		$('div.dialogBody').height($(top.document).find('#indicatorDialog').height()-$('div.dialogButtons').outerHeight(false)-10);
	}
	$('#doCommit').on('click', function(){
		//画面遷移中は他のボタンを効かないようにする
		// disabledを使用するとサーバーにデータが送られ無くなってしまうため、
		// クリックイベントを無視する方向に変更する
		$('div.dialogButtons').children('input').on('click', function(){
			return false;
		});

		//メンテナンスモードの設定値を反映する
		if( $('#maintenanceModeOn').attr('checked') == 'checked' ){
			$('#operationMode', top.document).val('maintenance');
			//メンテナンスモードの値をクリアする
			$.jStorage.set('maintenanceMode', 'ON');
		}else{
			$('#operationMode', top.document).val('normal');
			//メンテナンスモードの値をクリアする
			$.jStorage.set('maintenanceMode', '');
		}
	});

	//メンテナンス機能の設定をラジオボックスに反映する
	var maintenanceData = $('#operationMode', top.document).val();
	if( maintenanceData == 'maintenance' ){
		$('#maintenanceModeOff').attr('checked', false);
		$('#maintenanceModeOn').attr('checked', 'checked');
	}else{
		$('#maintenanceModeOn').attr('checked', false);
		$('#maintenanceModeOff').attr('checked', 'checked');
	}
	//「変更前に戻す」ボタンを押した時には、初期の選択状態に戻す
	$('input[type=reset]').on('click', function(){
		if( maintenanceData == 'maintenance' ){
			$('#maintenanceModeOff').attr('checked', false);
			$('#maintenanceModeOn').attr('checked', 'checked');
		}else{
			$('#maintenanceModeOn').attr('checked', false);
			$('#maintenanceModeOff').attr('checked', 'checked');
		}
	});

	//ラジオボタンの値が変わった時の動作
	//選択状態を変更する
	$('input[name=maintenanceMode]').on('change', function(){
		if($(this).attr('id') == 'maintenanceModeOn'){
			$('#maintenanceModeOff').attr('checked', false);
			$('#maintenanceModeOn').attr('checked', 'checked');
		}else{
			$('#maintenanceModeOn').attr('checked', false);
			$('#maintenanceModeOff').attr('checked', 'checked');
		}
	});

});
