//*****************************************************************************
// Copyright (C) 2013 SAY Technologies, Inc. All rights reserved.
//*****************************************************************************
$(document).ready(function() {
	var useragent= navigator.userAgent;
	if(useragent.search(/iPad/) != -1){
		//ダイアログの高さを設定する
		$('div.dialogBody').height($(top.document).find('#indicatorDialog').height()-$('div.dialogButtons').outerHeight(false)-10);
	}
	// ポーリング設定のEnable/Disable連動
	$('#pollingEnableTrue,#pollingEnableFalse').change(function() {
		if ($('#pollingEnableTrue:checked').val() == 'true') {
			$('#pollingInterval').removeAttr('disabled');
		} else if ($('#pollingEnableFalse:checked').val() == 'false') {
			$('#pollingInterval').attr('disabled', 'disabled');
		}
	});
	$('#pollingEnableTrue,#pollingEnableFalse').change();

	// リセットボタンを押した時の動作
	$('div.dialogButtons input[type=reset]').on('click', function(){
		$('#groupEditForm').get(0).reset();
		$('#pollingEnableTrue,#pollingEnableFalse').change();
		return false;
	});

	var ajaxParam = {'AjaxParam0' : ''};
	ajaxParam.onFailure = onAjaxFailure;
	Kumu.Ajax.executeTeedaAjax(group_groupEditAction_ajaxAutoCompleteCandidate, ajaxParam, Kumu.Ajax.RESPONSE_TYPE_JSON);

	$('#doConfirm,#jumpGroupView').on('click', function(){
		//画面遷移中は他のボタンを効かないようにする
		// disabledを使用するとサーバーにデータが送られ無くなってしまうため、
		// クリックイベントを無視する方向に変更する
		$('div.dialogButtons').children('input').on('click', function(){
			return false;
		});
	});
	//オートコンプリートの表示が横にずれる問題の対策
	//<body>の幅をそのwindowの幅に設定する
	$('body').width($(window).width());
});

//=============================================================================
//Ajaxコールバック関数
//=============================================================================
function group_groupEditAction_ajaxAutoCompleteCandidate(autoCompleteCandidate) {
	if (autoCompleteCandidate.length > 0) {
		$('#parentGroupPath').autocomplete({
			source: autoCompleteCandidate,
			delay : 50,
			minLength : 0
		});
	}
}

