
from sqlalchemy import Column, String

from app.models import Base, UpdatesMixin

class Configure(Base, UpdatesMixin):
    """サーバー設定
    """
    __tablename__ = "configure"

    ckey = Column(String(64), primary_key=True)
    cval = Column(String(1024), nullable=True)

    UPDATE_FIELDS = [
        "cval",
        "update_by",
    ]
