$(function() {
    $('#mnuLogout').on('click', function() {
        window.location.href = '/login';
    });

    $('#mnuChangePass').on('click', function() {
        window.location.href = '/change/user';
    });

    // dropdown アクション
    $(document).on('click', '.dropdown', function() {
        if ($(this).hasClass('is-active')) {
            $(this).removeClass('is-active');
        } else {
            $('div.dropdown').each(function() {
                $(this).removeClass('is-active');
            });
            $(this).addClass('is-active');
        }
    });

    $('input[type="number"]').on('blur', function(e) {
        let currVal = parseInt($(this).val()) || 0;
        let maxVal = parseInt($(this).prop("max")) || 0;
        let minVal = parseInt($(this).prop("min")) || 0;
        if (currVal > maxVal) {
            $(this).val(maxVal);
        } else if (currVal < minVal) {
            $(this).val(minVal);
        } else {
            $(this).val(currVal);
        }
    });
});
