
const viewResMailUse = function(checked) {
    if (checked) {
        $("#txtMail").prop('disabled', false).addClass("has-background-danger-light");
        $("#txtSubject").prop('disabled', false).addClass("has-background-danger-light");
        $("#txtBody").prop('disabled', false).addClass("has-background-danger-light");
    } else {
        $("#txtMail").prop('disabled', true).removeClass("has-background-danger-light");
        $("#txtSubject").prop('disabled', true).removeClass("has-background-danger-light");
        $("#txtBody").prop('disabled', true).removeClass("has-background-danger-light");
    }
};

const viewResWebhookUse = function(checked) {
    if (checked) {
        $("#txtUrl").prop('disabled', false).addClass("has-background-danger-light");
        $("#selMethod").prop('disabled', false);
        $("#txtHead").prop('disabled', false);
        $("#txtJson").prop('disabled', false);
    } else {
        $("#txtUrl").prop('disabled', true).removeClass("has-background-danger-light");
        $("#selMethod").prop('disabled', true);
        $("#txtHead").prop('disabled', true);
        $("#txtJson").prop('disabled', true);
    }
};

const viewResCmdUse = function(checked) {
    if (checked) {
        $("#txtCmd").prop('disabled', false).addClass("has-background-danger-light");
        $("#txtArgs").prop('disabled', false);
        $("#txtDirectory").prop('disabled', false);
        $("#chkMultiple").prop('disabled', false);
    } else {
        $("#txtCmd").prop('disabled', true).removeClass("has-background-danger-light");
        $("#txtArgs").prop('disabled', true);
        $("#txtDirectory").prop('disabled', true);
        $("#chkMultiple").prop('disabled', true);
    }
};

$(function() {
    $(function() {
        // initialize
    });

    $("#chkResMailUse").on('click', function() {
        viewResMailUse($(this).prop('checked'));
    });

    $("#chkResWebhookUse").on('click', function() {
        viewResWebhookUse($(this).prop('checked'));
    });

    $("#chkResCmdUse").on('click', function() {
        viewResCmdUse($(this).prop('checked'));
    });
});
