$(function() {
    $(function() {
        // initialize
        $(document).keydown(function(e){
            if (e.key == "Enter") {
                $("#btnLogin").click();
                return false;
            }
            return true;
        });
        $("#txtId").focus();
    });

    // ログインボタン押下
    $("#btnLogin").on('click', function() {
        // 初期化
        hideAlert();
        resetAllErrorEntity();
        var validateErrors = 0;

        const user_id = $("#txtId").val();
        if (user_id == "") {
            showErrorEntity($("#txtId"), "ユーザーID が入力されていません。");
            ++validateErrors;
        }
        const curr_pw = $("#txtPwd").val();
        if (curr_pw == "") {
            showErrorEntity($("#txtPwd"), "パスワードが入力されていません。");
            ++validateErrors;
        }

        if (validateErrors > 0) {
            return false;
        }

        $.ajax("/login/auth", {
            method: "POST",
            data: {
                user_id: user_id,
                pass_src: curr_pw,
            },
            cache: false,
            dataType: "json",
            jsonp: false,
        }).done(function(data, textStatus, jqXHR) {
            window.location.href = '/filter/list';
        }).fail(function(jqXHR, textStatus, errorThrown) {
            const alt_msg = responseToMessage(jqXHR);
            if (alt_msg.length > 0) {
                showAlert(alt_msg);
            }
        });
    });
});
