//*****************************************************************************
// Copyright (C) 2013 SAY Technologies, Inc. All rights reserved.
//*****************************************************************************
$(document).ready(function() {
	var useragent= navigator.userAgent;
	if(useragent.search(/iPad/) != -1){
		//ダイアログの高さを設定する
		$('div.dialogBody').height($(top.document).find('#indicatorDialog').height()-$('div.dialogButtons').outerHeight(false)-10);
	}
	// アクション種別
	if ($('#actionType').val() == 'CUSTOM') {
		// カスタムアクション選択
		$('.customAction').show();
		$('.mailAction').hide();
	} else if ($('#actionType').val() == 'MAIL') {
		// メールアクション選択
		$('.customAction').hide();
		$('.mailAction').show();
	}

	// メール認証
	if ($('#mailAuthenticationType').val() == 'SMTP_AUTH') {
		// 認証なし
		$('.mailSmtpAuthentication').show();
	} else {
		// SMTP AUTH
		$('.mailSmtpAuthentication').hide();
	}

	$('#doPrevious').on('click', function(){
		//画面遷移中は他のボタンを効かないようにする
		// disabledを使用するとサーバーにデータが送られ無くなってしまうため、
		// クリックイベントを無視する方向に変更する
		$('div.dialogButtons').children('input').on('click', function(){
			return false;
		});
	});
	$('#doCommit').on('click', function(){
		if($('#userAction').val() == '削除'){
			if (window.confirm("■警告■\n\n対象アクションを削除します。\n\nアクションの削除と共に下記のデータも削除されます。\n・アクションログ\n\nよろしいですか？") != true ) {
				return false;
			}
		}
		//画面遷移中は他のボタンを効かないようにする
		// disabledを使用するとサーバーにデータが送られ無くなってしまうため、
		// クリックイベントを無視する方向に変更する
		$('div.dialogButtons').children('input').on('click', function(){
			return false;
		});
	});
});


