SELECT
	bom_history_log_id,
	instance_id,
	datetime,
	type,
	category,
	summary,
	message
FROM
	bom_history_log
WHERE
	instance_id = /*instance_id*/1
	AND datetime = (
	 	SELECT
	 		max(datetime)
		FROM
			bom_history_log
		WHERE
			instance_id = /*instance_id*/1
		GROUP BY
			instance_id
	)  AND ROWNUM<=1
