SELECT
	bom_monitor_log_id,
	bom_monitor_log.instance_id,
	bom_monitor_log.bom_monitor_id,
	datetime,
	duration,
	result_code,
	value,
	status
FROM
	bom_monitor
	LEFT OUTER JOIN
	bom_monitor_log
	ON (bom_monitor.bom_monitor_id = bom_monitor_log.bom_monitor_id)
WHERE
	bom_monitor.instance_id = /*instance_id*/1
	AND bom_monitor.monitor_group_id = /*monitor_group_id*/'GRP01'
	AND bom_monitor.monitor_monitor_id = /*monitor_monitor_id*/'MON01'
	AND datetime = (
	 	SELECT
	 		max(datetime)
		FROM
			bom_monitor_log
		WHERE
			bom_monitor_id = (
				SELECT
					BOM_MONITOR_ID
				FROM
					BOM_MONITOR
				WHERE
					INSTANCE_ID = /*instance_id*/1
					AND MONITOR_GROUP_ID = /*monitor_group_id*/'GRP01'
					AND MONITOR_MONITOR_ID = /*monitor_monitor_id*/'MON01'
			)
		GROUP BY
			instance_id,
			bom_monitor_id
	) AND ROWNUM<=1
