SELECT
  instance_id,
  BOOL_OR(POLLING_STATUS_DISCONNECT_COMPUTER) AS polling_status_disconnect_computer,
  BOOL_OR(POLLING_STATUS_DISCONNECT_HELPER) AS polling_status_disconnect_helper,
  BOOL_OR(POLLING_STATUS_DISCONNECT_AGENT) AS polling_status_disconnect_agent,
  SUM(failure_count) AS failure_count,
  SUM(danger_count) AS danger_count,
  SUM(warning_count) AS warning_count,
  SUM(normal_count) AS normal_count,
  BOOL_OR(CONFIRM_STATUS) AS confirm_status
FROM
	instance_log
WHERE
	instance_id IN /*instance_id_list*/(1,2)
	AND	confirm_status = false
GROUP BY
  instance_id
