SELECT
	action_id,
	action_name,
	group_id,
	enabled,
	condition_normal,
	condition_warning,
	condition_danger,
	condition_failure,
	condition_monitor_disconnect,
	condition_helper_disconnect,
	condition_computer_disconnect,
	action_kind,
	action_command,
	action_params,
	action_working_directory,
	create_datetime,
	create_user_id,
	(SELECT user_name FROM user WHERE user_id = action.create_user_id) AS create_user_name,
	update_datetime,
	update_user_id,
	(SELECT user_name FROM user WHERE user_id = action.update_user_id) AS update_user_name,
	single_run
FROM
	action
WHERE
	action_id=/*action_id*/1
