CREATE TABLE action(
	action_id						IDENTITY	PRIMARY KEY,
	action_name						VARCHAR		NOT NULL,
	group_id						BIGINT		NOT NULL,
	enabled							BOOLEAN		NOT NULL,
	condition_normal				BOOLEAN		NOT NULL,
	condition_warning				BOOLEAN		NOT NULL,
	condition_danger				BOOLEAN		NOT NULL,
	condition_failure				BOOLEAN		NOT NULL,
	condition_monitor_disconnect	BOOLEAN		NOT NULL,
	condition_helper_disconnect		BOOLEAN		NOT NULL,
	condition_computer_disconnect	BOOLEAN		NOT NULL,
	action_kind						VARCHAR		NOT NULL,
	action_command					VARCHAR		NOT NULL,
	action_params					VARCHAR		NOT NULL,
	action_working_directory		VARCHAR		,
	create_datetime					TIMESTAMP	NOT NULL,
	create_user_id					VARCHAR		NOT NULL,
	update_datetime					TIMESTAMP	NOT NULL,
	update_user_id					VARCHAR		NOT NULL,
	single_run						BOOLEAN		NOT NULL,
	UNIQUE(group_id, action_name)
);