CREATE TABLE bom_monitor(
	bom_monitor_id					IDENTITY	PRIMARY KEY,
	instance_id						BIGINT		NOT NULL,
	monitor_type					VARCHAR,
	monitor_group_id				VARCHAR,
	monitor_monitor_id				VARCHAR,
	monitor_name					VARCHAR,
	monitor_started_time			TIMESTAMP,
	monitor_interval				INTEGER,
	monitor_interval_unit			VARCHAR,
	clsid							VARCHAR,
	object_name						VARCHAR,
	value_name						VARCHAR,
	options							VARCHAR,
	danger_value					VARCHAR,
	danger_type						VARCHAR,
	warning_value					VARCHAR,
	warning_type					VARCHAR,
	comment							VARCHAR,
	icon_index						INTEGER,
	enabled							BOOLEAN,
	display_unit					VARCHAR,
	scale							BIGINT,
	create_datetime					TIMESTAMP	NOT NULL,
	create_user_id					VARCHAR		NOT NULL,
	update_datetime					TIMESTAMP	NOT NULL,
	update_user_id					VARCHAR		NOT NULL,
	UNIQUE(instance_id, monitor_group_id, monitor_monitor_id)
);