SELECT
	user_id,
	user_name,
	password_encrypted,
	user_master.role_id,
	user_master.last_password_update_datetime,
	user_master.create_datetime,
	user_master.create_user_id,
	(SELECT user_name FROM user WHERE user_id = user_master.create_user_id) AS create_user_name,
	user_master.update_datetime,
	user_master.update_user_id,
	(SELECT user_name FROM user WHERE user_id = user_master.update_user_id) AS update_user_name,
	(SELECT value FROM Setting WHERE user_id = user_master.user_id AND kind = 'LAST_LOGIN_DATETIME') AS last_login_datetime,
	role_name,
	loginable,
	permission_write,
	single_session
FROM
	user user_master
	LEFT OUTER JOIN
	role
	ON (user_master.role_id = role.role_id)
ORDER BY
	UPPER(user_name)
